function [nParams wIndex vIndex] = HCRFGetParamIndex(nX, nH, dA, dI)
% return the information of HCRF parameters
%nX: number of labels
%nH: number of latent states
%dA: dimension of association features
%dI: dimension of interaction features
%nParams: number of total parameters
%muIndex: index of association parameters
%lambdaIndex: index of interaction paramters

if nargin == 1 && isstruct(nX)
    model=nX;
    nX=model.nX;
    nH=model.nH;
    dA=model.dimA;
    dI=model.dimI;
end

nParams=dA*nH*nX + dI*nH*nH;

wIndex=1:(nX*nH*dA);
vIndex=(nX*nH*dA + 1):(nX*nH*dA + dI*nH*nH);
