function [data, enums] = HCRFSetup(data, T, K, nnk, cluster, g_order, max_cluster, isenums)

if nargin < 7
    max_cluster = 5;
end
if ~exist('isenums','var')
   isenums = 1;
end
max_cluster_tmp = max_cluster;

N = length(data);
max_nNode = -1;
for ind = 1:N
    w = data{ind};
    
    if cluster % make clustered graph
        if isnan(max_cluster_tmp)  %%added by jieyuel 2011-1-26
           max_cluster = length(unique(w.cellids))*5;  %%'./data/pc/structFeat-KN3-anti2.mat'
        end  %%
        ncluster = max(1,round(size(w.F,1)*0.2));  %%
        if size(w.Centers,1)<=1  %%
           w.NID = 1;  %%
        else  %%
        for jnd = 1:10
            w.NID = kmeans(w.Centers, ncluster, 'emptyaction','singleton','replicates',3);
            if min(accumarray(w.NID(:), 1)) > 1
                break;
            end
        end
        end
%         scatter(w.Centers(:,1), w.Centers(:,2), [], w.NID, 'marker','.');pause;
        
        sizes = accumarray(w.NID(:), 1);
        for jnd = 1:length(sizes)
            if sizes(jnd) > max_cluster
                filter = find(w.NID == jnd);
                w.NID(filter(RI(sizes(jnd) - max_cluster, length(filter)))) = 0;
            end
        end
        filter = w.NID > 0;
        w.F = w.F(filter, :);  
        w.Centers = w.Centers(filter, :);
        w.NID = w.NID(filter, :);
        
        sizes = accumarray(w.NID(:), 1);
        if min(sizes) < 1 || max(sizes) > max_cluster
            error('partitioning failed');
        end
        
        max_nNode = max(max_nNode, max(sizes));
    else
        max_nNode = max(max_nNode, size(w.F, 1));
    end
    
    %edges = MakeKNNGraph(w.Centers, nnk);
    edges = MakeKNNGraph(w.Centers, min(size(w.Centers,1)-1,nnk));
    w.E = int32([edges(:, [1,2]); edges(:, [2,1])]);
    w.G = repmat(edges(:,3),2,1);
    if cluster % make clustered graph
        eid = EncodeInt(w.E, int32(1:size(w.F,1)), w.NID);
        filter = eid(:,1) == eid(:,2);
        w.E = w.E(filter, :);
        w.G = w.G(filter, :);
    end

    data{ind} = w;
end
clear w

% preprocess features
F = AssembleMatrix(data, 'F', true); %F = zscore(F);  %%
%{
st = [];
for i = 1:ceil(size(F,2)/100)
      st = [st,std(F(:,(i-1)*100+1:min(i*100,size(F,2))),1)];
end
mu = mean(F,1);
F = bsxfun(@rdivide,bsxfun(@minus, F, mu),st);
clear mu st
%}

F = [ones(size(F,1),1) F];
G = AssembleMatrix(data, 'G', true);gg = zscore(G);
G = [ones(size(G,1),1) gg];
for ind = 2:g_order
    G = [G, gg.^ind];
end
Fs = mat2cell(F, cellfun(@(x) size(x.F,1), data)); clear F
Gs = mat2cell(G, cellfun(@(x) size(x.G,1), data)); clear G
for ind = 1:length(data)
    data{ind}.F = Fs{ind};
    data{ind}.G = Gs{ind};
end
clear F G gg Fs Gs

if isenums==1
enums = cell(1, max_nNode);
for ind = 1:max_nNode
    enums{ind} = int32(GetCombinations([repmat(T,1,ind), K]));
    %enums{ind} = uint8(GetCombinations([repmat(T,1,ind), K]));  %%
end
else
enums = [];
end
