function [obj, grad] = HLRValue(x, F, Y, T, lam)

M = size(F,1);
D = size(F,2);
K = size(Y,2);

[ C, PC_F, PCO_F] = HLRTest( F, reshape(x, [D, T, K]) );

obj = -sum(log(1e-100+PC_F(find(Y)))) ...
    + 0.5*lam*(sum(x.^2));

if nargout > 1
    PO_CF = bsxfun(@times, bsxfun(@times, PCO_F, reshape(full(Y),[M,1,K])), 1./reshape(PC_F + 1e-100, [M,1,K]));

    grad = F'*reshape(PO_CF - PCO_F, [M,T*K]);
    grad = -grad(:)+lam*x;
end
