%% script for feature reduction and preprocess

datafile = './data/pc/fg9_single_A431R2.mat';

load(datafile, 'classlabels', 'classes', 'antibodyids', 'allfeatures', 'names', 'locations', 'center_prot', 'cellids', 'imagelist');

allfeatures = single(allfeatures); %

allfeatures(isnan(allfeatures)) = 0;

tmpmax = max(allfeatures,[],1);
tmpmin = min(allfeatures,[],1);
tmpidx = find((tmpmax-tmpmin)<=1e-2);
allfeatures(:,tmpidx) = [];
c_del = unique(tmpidx);  %%

[tmpr,tmpc] = find(isinf(allfeatures));
allfeatures(:,unique(tmpc)) = []; %%
c_del = [c_del(:);unique(tmpc)]; c_del = unique(c_del);  %%

allfeatures = zscore(allfeatures);

allfeatures1 = [];

idx1 = setdiff([1:558],c_del);
allfeatures1 = allfeatures(:,idx1);
allfeatures(:,idx1) = [];
model = PCA(allfeatures1,0.95);  %%
allfeatures1 = Project(model,allfeatures1);
size(allfeatures1,2)

model = PCA(allfeatures,0.95);  %%
allfeatures = Project(model,allfeatures);
size(allfeatures,2)
allfeatures = [allfeatures1,allfeatures];
clear allfeatures1
allfeatures = double(allfeatures);

locations = double(locations);
classlabels = double(classlabels);
antibodyids = double(antibodyids);
center_prot = double(center_prot);  %%


if length(unique(classlabels))~=length(classes)
   error('Some class has been deleted!');
end

proteins = unique(antibodyids);

nr = 50;
W = [];
KN = 3;
nc = ceil(length(classlabels)/nr);
Sampling = 1;%

load(datafile,'imagelist');
for i=1:length(imagelist)
    imagelist{i} = [imagelist{i},num2str(cellids(i))];
end
images = unique(imagelist);
for i=1:length(images)
    i
    idx = find(strcmp(images{i},imagelist));
    length(idx)
    if length(unique(classlabels(idx)))~=1 || length(unique(antibodyids(idx)))~=1 || length(unique(cellids(idx)))~=1 %|| length(idx)~=floor(nr/Sampling) 
        warning('Check labels!.');
        if length(unique(cellids(idx)))~=1
           tmp_anti = cellids(idx(1));
           tmpidx = find(cellids(idx)==tmp_anti);
        elseif length(unique(antibodyids(idx)))~=1 
           tmp_anti = antibodyids(idx(1));
           tmpidx = find(antibodyids(idx)==tmp_anti);
        end

        idx = idx(tmpidx);
        if length(unique(classlabels(idx)))~=1 || length(unique(antibodyids(idx)))~=1 %|| length(idx)~=floor(nr/Sampling) 
           error('Check labels!.');
        end
    end
    W(i).G = allfeatures(idx,:);
    W(i).L = unique(classlabels(idx));
    W(i).Center = locations(idx,:);
    W(i).P = [];
    W(i).F = [];
    W(i).anti = unique(antibodyids(idx));
    W(i).center_prot = center_prot(idx(1),:);  %%

    ydist = squareform(pdist(W(i).Center));
    for j=1:size(ydist,1)
        tmpdist = ydist(j,:);
        [sortD, sortI] = sort(tmpdist,'ascend');
        W(i).P = [W(i).P;[j*ones(length(sortI(2:min(KN+1,end))'),1),sortI(2:min(KN+1,end))']];
        W(i).F = [W(i).F;sortD(2:min(KN+1,end))'];
    end

end

save('./data/pc/structFeat9-KN3.mat','KN','Sampling','W','classes');
