%% script for using HCRF

close all
clear all


tmpfolder = './tmptmp/';
if ~exist(tmpfolder, 'dir')
   mkdir(tmpfolder);
end

nNode = 50;
nnk = 5;

dataname = './data/pc/structFeat9-KN3.mat';

Ts_all = 1:6;
Nfolds_all = 1:5;
foldfile_ind = 1:5;

for iTs = Ts_all
for iNfolds = Nfolds_all
for ifoldfile = foldfile_ind

alltmpfile = [tmpfolder,'pc-9-',num2str(ifoldfile),'-',num2str(iNfolds),'-',num2str(iTs),'.txt'];
if exist(alltmpfile, 'file')
   continue;
end
alltmpfile

allfid = fopen(alltmpfile, 'w');

outfolder = ['./tmp/pc-9-',num2str(ifoldfile),'/'];

if ~exist('outfolder','dir')
   mkdir(outfolder);
end

Ts = iTs;  %%

SDA = 0;
ntry = 1; %%
ridge = 100;
%ridge = 1000;
separate = true;

load(['./data/pc/regionfeatures_5folds',num2str(ifoldfile),'.mat'], 'Nfolds', 'trainidx', 'testidx');
Nfolds = iNfolds;  %%

tmpfile = [outfolder,'batch_cell',num2str(Ts),num2str(Nfolds),'.txt']; 
fid = fopen(tmpfile,'w');

accss = zeros(8, length(Ts), ntry, length(Nfolds));
for iii = 1:ntry
    for jjj = 1:length(Ts)
        disp([iii jjj]);
        
        T = Ts(jjj);
        for nf = Nfolds
            disp(['evaluating fold: ' num2str(nf)]); 

            fprintf(fid,'iii %d, jjj %d, T %d, nfold %d.\n',iii,jjj,T,nf);
            run_crf2;
            accss(:,jjj,iii,nf) = accs(:);
        
            save([outfolder,'accss',num2str(iii),'-',num2str(T),'-',num2str(nf),'.mat']); 
            save([outfolder,'accss',num2str(T),num2str(nf),'.mat'],'accss');
        end
    end
end

%%


fclose(fid);
fclose(allfid);

end % end of ifoldfile
end % end of iNfolds 
end % end of iTs 
