% T = 2;
% K = 5;
% M = 10;
% N = 200;
% nnk = 3;
% loc = true;
% noise = 0.1;
% 
% data = simulation(T, K, M, N, noise, loc);
% [data enums] = HCRFSetup(data, T, K, nnk, true, 1, M);
% 
% trI = RI(round(N*0.5), N);
% teI = L2I(~I2L(trI, N));

data_ne = data;
for ind = 1:length(data)
    data_ne{ind}.G = [];
    data_ne{ind}.E = [];
end

labels = AssembleVector(data, 'L');
[nNode dA] = size(data{1}.F);
dI = size(data{1}.G, 2);

options = struct('nX',K,'nH',T,'ridge',1e1*T,'enums',{enums});

%% hlr region classifier

F = AssembleMatrix(data(trI), 'F', true);
labels_r = kron(labels(trI), ones(nNode,1));
Y = sparse(1:length(labels_r), labels_r, 1, length(labels_r), K);

options.Method = 'lbfgs';
options.MaxIter = 200;
options.Display = 'off';
func = @(x) HLRValue(x, F, Y, T, options.ridge);
WS = cell(1,3);objs = zeros(1,length(WS));
for ind = 1:length(WS)
    [WS{ind}, objs(ind)] = minFunc(func, randn(dA*T*K, 1), options);
end
W = reshape(WS{argmin(objs)},[dA,T,K]);

t_hlr_r = HLRTest(AssembleMatrix(data(teI), 'F', true), W);
t_hlr = Vote(t_hlr_r, kron((1:length(teI))',ones(nNode,1)));
acc_hlr_r = mean(t_hlr_r == kron(labels(teI), ones(nNode,1)))
acc_hlr_c = mean(t_hlr == labels(teI))

%% hcrf lbfgs ne

options.Method = 'lbfgs';
options.maxIter = 100;
nparam = HCRFGetParamIndex(K, T, dA, 0);
WS = cell(1,3);objs = zeros(1, length(WS));
for ind = 1:length(WS)
    options.init = randn(nparam,1);
    [WS{ind} objs(ind)] = HCRFTrain(data_ne(trI), options);
end
model_ne = WS{argmin(objs)};

t_hcrfne_tr = HCRFTest(data_ne(trI), model_ne, options);
t_hcrfne_c = HCRFTest(data_ne(teI), model_ne, options);
acc_hcrfne_tr = mean(t_hcrfne_tr(:) == labels(trI))
acc_hcrfne_c = mean(t_hcrfne_c(:) == labels(teI))

%% cluster 

[nparam wi] = HCRFGetParamIndex(K, T, dA, dI);
options.init = randn(nparam,1)*1e-5; options.init(wi) = model_ne.theta;
modelc = HCRFTrain(data(trI), options);

t_hcrfc_tr = HCRFTest(data(trI), modelc, options);
t_hcrfc_c = HCRFTest(data(teI), modelc, options);
acc_hcrfc_tr = mean(t_hcrfc_tr(:) == labels(trI))
acc_hcrfc_c = mean(t_hcrfc_c(:) == labels(teI))

%%

accs = [acc_hlr_r,acc_hlr_c,...
    acc_hcrfne_tr,acc_hcrfne_c,...
    acc_hcrfc_tr,acc_hcrfc_c];
