#include "mex.h"
#include <vector>
#include <memory.h>
#include "ex-utils.h"

using namespace std;

void CheckInput(int nlhs, mxArray *plhs[], int nrhs, const mxArray *prhs[])
{
  /* Check for proper number of arguments. */
  if (nrhs != 1 || (mxGetClassID(prhs[0]) != mxINT32_CLASS) ) {
      mexErrMsgTxt("get the index of unique values of an int array.\n\
		Usage: I=ArgUnique(A)\n\
                  A: original array. \n\
                  I: indeces of unique values of A.\n");
  }
}

void mexFunction(int nlhs, mxArray *plhs[], int nrhs,const mxArray *prhs[])
{
  mwSize n, i;
  INT32 *pA;
  hash_set<INT32> ht;
  vector<mwSize> uv;
	
  CheckInput(nlhs, plhs, nrhs, prhs);
    
  pA = (INT32*)mxGetPr(prhs[0]);
  n = mxGetNumberOfElements(prhs[0]);
    
  for(i = 0 ; i < n ; i ++) {
    if(ht.find(pA[i]) == ht.end()) {
      ht.insert(pA[i]);
      uv.push_back(i+1);
    }
  }
    
  //result
  plhs[0]=mxCreateNumericMatrix(uv.size(), 1, 
          sizeof(mwSize) == 4 ? mxUINT32_CLASS: mxUINT64_CLASS, mxREAL);
  memcpy(mxGetPr(plhs[0]), &uv[0], uv.size()*sizeof(mwSize));
}
