function [ r ] = AssembleMatrix( cs, fieldname, by_row, fieldname_ref )
%[ r ] = AssembleMatrix( cs, fieldname, by_row )
%ASSEMBLECELLS assemble a field in cell array into a long matrix
% matrices are combined by columns
% if by_row, matrices are combined by rows

if ~exist('fieldname_ref','var')
   fieldname_ref  = [];
end

if nargin < 3
	by_row=false;
	if nargin < 2
		fieldname=[];
	end
end

cs_original = cs;
if ~isempty(fieldname)
    cs=cellfun(@(x) x.(fieldname), cs, 'UniformOutput', false);
end

r=cat(choose(by_row, 1, 2), cs{:});

if ~isempty(fieldname_ref)
   len = cellfun(@(x) size(x.(fieldname_ref),1), cs_original, 'UniformOutput', false);
   len = cell2mat(len);
   
   r2 = [];
   for i=1:length(len)
       r2=[r2;repmat(r(i),[len(i),1])];
   end
   r = r2;
end
