switch fsetnames{zed}
  case 'tas'
    [names, feats, slfnames] = ml_tas( protstruct.channel,0);

  case 'tasx2'
    downsampleProteinChannel
    
    [names, feats, slfnames] = ml_tas( protstruct.downsampled2x,0);
    
    renameDownsampled

  case 'mutualInfo'
    loadNucleusChannel; loadMicrotubuleChannel; loadERChannel; 
    
    sprot = size(protstruct.channel);
    prot_re = reshape(protstruct.channel,[sprot(1)*sprot(2) 1]);
    nuc_re = reshape(nucstruct.channel,[sprot(1)*sprot(2) 1]);
    tub_re = reshape(tubstruct.channel,[sprot(1)*sprot(2) 1]);
    er_re = reshape(erstruct.channel,[sprot(1)*sprot(2) 1]);

    commonScriptMutualInformation
    
  case 'mutualInfox2'
    loadNucleusChannel; loadMicrotubuleChannel; loadERChannel; 

    downsampleAllChannels

    sprot = size(protstruct.downsampled2x);
    prot_re = reshape(protstruct.downsampled2x,[sprot(1)*sprot(2) 1]);
    nuc_re = reshape(nucstruct.downsampled2x,[sprot(1)*sprot(2) 1]);
    tub_re = reshape(tubstruct.downsampled2x,[sprot(1)*sprot(2) 1]);
    er_re = reshape(erstruct.downsampled2x,[sprot(1)*sprot(2) 1]);

    commonScriptMutualInformation

    renameDownsampled

  case 'texture'
    prot = protstruct.channel;
    commonScriptTexture

  case 'texturex2'
    downsampleProteinChannel

    prot = protstruct.downsampled2x;
    commonScriptTexture

    renameDownsampled

  case 'texturex4'
    DSF = 4;
    downsampleProteinChannel

    prot = protstruct.downsampled4x;
    commonScriptTexture

    renameDownsampled
    DSF = 2;

  case 'overlap'
    loadNucleusChannel; loadMicrotubuleChannel; loadERChannel;

    thresholdAllChannels

    tmp_prot = protstruct.channel;
    tmp_prot_fg = protstruct.channel_fg;
    tmp_nuc_fg = nucstruct.channel_fg;
    tmp_tub_fg = tubstruct.channel_fg;
    tmp_er_fg = erstruct.channel_fg;
    tmp_prot_mfg = protstruct.channel_mfg;
    tmp_prot_large_fg = protstruct.channel_large_fg;
    tmp_prot_large_mfg = protstruct.channel_large_mfg;

    commonScriptOverlap

  case 'overlapx2'
    loadNucleusChannel; loadMicrotubuleChannel; loadERChannel;

    downsampleAllChannels

    thresholdDownsampled2xAllChannels

    tmp_prot = protstruct.downsampled2x;
    tmp_prot_fg = protstruct.downsampled2x_fg;
    tmp_nuc_fg = nucstruct.downsampled2x_fg;
    tmp_tub_fg = tubstruct.downsampled2x_fg;
    tmp_er_fg = erstruct.downsampled2x_fg;
    tmp_prot_mfg = protstruct.downsampled2x_mfg;
    tmp_prot_large_fg = protstruct.downsampled2x_large_fg;
    tmp_prot_large_mfg = protstruct.downsampled2x_large_mfg;

    commonScriptOverlap

    renameDownsampled

  case 'nonObjFluor'
    loadNucleusChannel; loadMicrotubuleChannel; loadERChannel;

    thresholdAllChannels

    prot_int = sum(sum(protstruct.channel_fg));
    bg_prot = protstruct.channel;
    bg_prot(protstruct.channel>protstruct.channel_thr) = 0;
    prot_int_large = sum(sum(protstruct.channel_large_fg));

    prot_int_mthr = sum(sum(protstruct.channel_mfg));
    bg_prot_mthr = protstruct.channel;
    bg_prot_mthr(protstruct.channel>protstruct.channel_mthr) = 0;
    prot_int_large_mthr = sum(sum(protstruct.channel_large_mfg));

    commonScriptNOF

  case 'nonObjFluorx2'
    loadNucleusChannel; loadMicrotubuleChannel; loadERChannel;

    downsampleAllChannels

    thresholdDownsampled2xAllChannels

    prot_int = sum(protstruct.downsampled2x_fg(:));
    bg_prot = protstruct.downsampled2x;
    bg_prot(protstruct.downsampled2x>protstruct.downsampled2x_thr) = 0;
    prot_int_large = sum(protstruct.downsampled2x_large_fg(:));

    prot_int_mthr = sum(protstruct.downsampled2x_mfg(:));
    bg_prot_mthr = protstruct.downsampled2x;
    bg_prot_mthr(protstruct.downsampled2x>protstruct.downsampled2x_mthr) = 0;
    prot_int_large_mthr = sum(protstruct.downsampled2x_large_mfg(:));

    commonScriptNOF

    renameDownsampled

  case 'obj'
    loadNucleusChannel

    thresholdProteinChannel;  thresholdNucleusChannel;

    protobjs = protstruct.channel_objectsizes;
    largeprotobjs = protstruct.channel_large_objectsizes;

    protobjs_mthr = protstruct.channel_mobjectsizes;
    largeprotobjs_mthr = protstruct.channel_large_mobjectsizes;

    nucobjs = nucstruct.channel_objectsizes;

    normEuN = bweuler(protstruct.channel_fg>0,8)/length(nucobjs);
    normEuN_mthr = bweuler(protstruct.channel_mfg>0,8)/length(nucobjs);

    commonScriptObject;

  case 'objx2'
    loadNucleusChannel

    downsampleProteinChannel;  downsampleNucleusChannel;

    thresholdDownsampled2xProteinChannel;  thresholdDownsampled2xNucleusChannel;

    protobjs = protstruct.downsampled2x_objectsizes;
    largeprotobjs = protstruct.downsampled2x_large_objectsizes;

    protobjs_mthr = protstruct.downsampled2x_mobjectsizes;
    largeprotobjs_mthr = protstruct.downsampled2x_large_mobjectsizes;

    nucobjs = nucstruct.downsampled2x_objectsizes;

    normEuN = bweuler(protstruct.downsampled2x_fg>0,8)/length(nucobjs);
    normEuN_mthr = bweuler(protstruct.downsampled2x_mfg>0,8)/length(nucobjs);

    commonScriptObject;

    renameDownsampled

  case 'objRegion'
    loadNucleusChannel

    thresholdProteinChannel;  thresholdNucleusChannel;

    [names, feats, slfnames] = ml_imgfeatures( protstruct.channel_fg, nucstruct.channel_fg);

    if length(feats)~=14
        feats = repmat(nan, [1 14]);
    end

  case 'objRegionx2'
    loadNucleusChannel

    downsampleProteinChannel;  downsampleNucleusChannel;

    thresholdDownsampled2xProteinChannel;  thresholdDownsampled2xNucleusChannel;

    [names, feats, slfnames] = ml_imgfeatures( protstruct.downsampled2x_fg, nucstruct.downsampled2x_fg);

    if length(feats)~=14
        feats = repmat(nan, [1 14]);
    end

    renameDownsampled

  case 'LargeSpots'

    %loadNucleusChannel

    %thresholdProteinChannel;  %%
    %thresholdNucleusChannel;

    %[feats,names,slfnames] = imfiltercorr(protstruct.channel_fg,nucstruct.channel_fg,hsize,hband,corrthre);
    %[feats,names,slfnames] = imfiltercorr(protstruct.channel_fg,hsize,hband,corrthre);
    [feats,names,slfnames] = imfiltercorr(protstruct.channel,hsize,hband,corrthre);  %without thresholdProteinChannel
 
    %{
    if length(feats)~=14 %%
        feats = repmat(nan, [1 14]);  %%
    end
    %}


  case 'sDist2ref'
    loadNucleusChannel;

    thresholdAllChannels

    tmp_prot = protstruct.channel;
    tmp_prot_fg = protstruct.channel_fg;
    tmp_nuc_fg = nucstruct.channel_fg;
    tmp_prot_mfg = protstruct.channel_mfg;
    tmp_prot_large_fg = protstruct.channel_large_fg;
    tmp_prot_large_mfg = protstruct.channel_large_mfg;

    [feats1,names1] = sDist2ref(tmp_prot_fg, tmp_nuc_fg, 'nuc');
    %[feats1,names1] = sDist2ref( tmp_prot, tmp_prot_fg, tmp_nuc_fg, 'nuc');

    [feats2,names2] = sDist2ref(tmp_prot_large_fg, tmp_nuc_fg, 'nuc_large');

    [feats3,names3] = sDist2ref(tmp_prot_mfg, tmp_nuc_fg, 'nuc_mthr');
    
    [feats4,names4] = sDist2ref(tmp_prot_large_mfg, tmp_nuc_fg, 'nuc_mthr_large');

    feats = [feats1 feats2 feats3 feats4];
    names = [names1 names2 names3 names4];
    slfnames = repmat({''},[1 length(names)]);
    

  case 'sDist2refByFluo'
    loadNucleusChannel;

    thresholdAllChannels

    tmp_prot = protstruct.channel;
    tmp_prot_fg = protstruct.channel_fg;
    tmp_nuc_fg = nucstruct.channel_fg;
    tmp_prot_mfg = protstruct.channel_mfg;
    tmp_prot_large_fg = protstruct.channel_large_fg;
    tmp_prot_large_mfg = protstruct.channel_large_mfg;

    [feats1,names1] = sDist2refByFluo(tmp_prot_fg, tmp_nuc_fg, 'nuc');
    %[feats1,names1] = sDist2refByFluo( tmp_prot, tmp_prot_fg, tmp_nuc_fg, 'nuc');

    [feats2,names2] = sDist2refByFluo(tmp_prot_large_fg, tmp_nuc_fg, 'nuc_large');

    [feats3,names3] = sDist2refByFluo(tmp_prot_mfg, tmp_nuc_fg, 'nuc_mthr');
    
    [feats4,names4] = sDist2refByFluo(tmp_prot_large_mfg, tmp_nuc_fg, 'nuc_mthr_large');

    feats = [feats1 feats2 feats3 feats4];
    names = [names1 names2 names3 names4];
    slfnames = repmat({''},[1 length(names)]);


  case 'PsDist2refFW'
    loadNucleusChannel;

    thresholdAllChannels

    tmp_prot = protstruct.channel;
    tmp_prot_fg = protstruct.channel_fg;
    tmp_nuc_fg = nucstruct.channel_fg;
    tmp_prot_mfg = protstruct.channel_mfg;
    tmp_prot_large_fg = protstruct.channel_large_fg;
    tmp_prot_large_mfg = protstruct.channel_large_mfg;

    [feats1,names1] = PsDist2refFW(tmp_prot_fg, tmp_nuc_fg, 'nuc');
    %[feats1,names1] = PsDist2refFW( tmp_prot, tmp_prot_fg, tmp_nuc_fg, 'nuc');

    [feats2,names2] = PsDist2refFW(tmp_prot_large_fg, tmp_nuc_fg, 'nuc_large');

    [feats3,names3] = PsDist2refFW(tmp_prot_mfg, tmp_nuc_fg, 'nuc_mthr');
    
    [feats4,names4] = PsDist2refFW(tmp_prot_large_mfg, tmp_nuc_fg, 'nuc_mthr_large');

    feats = [feats1 feats2 feats3 feats4];
    names = [names1 names2 names3 names4];
    slfnames = repmat({''},[1 length(names)]);

  case 'zernike'
    [names, feats] = zernike(protstruct.channel,4,1);
    slfnames = repmat({''},[1 length(names)]);

  case 'zernikex2'
    downsampleProteinChannel

    [names, feats] = zernike(protstruct.downsampled2x,4,1);
    slfnames = repmat({''},[1 length(names)]);
    
    renameDownsampled

  case 'edge'
    thresholdProteinChannel; 

    [names, feats, slfnames] = ml_imgedgefeatures(protstruct.channel_fg)

  case 'edgex2'
    downsampleProteinChannel; 

    thresholdDownsampled2xProteinChannel; 

    [names, feats, slfnames] = ml_imgedgefeatures( protstruct.downsampled2x_fg);
    
    renameDownsampled

  case 'SOF1'
    loadNucleusChannel

    thresholdProteinChannel;  thresholdNucleusChannel; %
    %An alternative is to use ml_preprocess in SLIC.
    %[protstruct.channel_fg,mask,res] = ml_preprocess(protstruct.channel,[],'ml','yesbgsub'); %Warning: No protein fluorescence left after preprocessing
    %[nucstruct.channel_fg,mask,res] = ml_preprocess(nucstruct.channel,[],'ml','yesbgsub'); %Warning: No protein fluorescence left after preprocessing

    [names, feats, slfnames] = objectfeat1(protstruct.channel_fg, nucstruct.channel_fg, cellid);

  case 'allobjects'  %This is not to calculate any feature but to get all objects.
    loadNucleusChannel

    thresholdProteinChannel;  thresholdNucleusChannel; %

    [names, feats, slfnames] = getallobjs(protstruct.channel_fg, nucstruct.channel_fg, cellid);

  case 'SOF2'
    loadNucleusChannel

    thresholdProteinChannel;  thresholdNucleusChannel; %
    %An alternative is to use ml_preprocess in SLIC.
    %[protstruct.channel_fg,mask,res] = ml_preprocess(protstruct.channel,[],'ml','yesbgsub'); %Warning: No protein fluorescence left after preprocessing
    %[nucstruct.channel_fg,mask,res] = ml_preprocess(nucstruct.channel,[],'ml','yesbgsub'); %Warning: No protein fluorescence left after preprocessing

    [names, feats, slfnames] = objectfeat2(protstruct.channel_fg, nucstruct.channel_fg, cellid);

  case 'fg'
    loadNucleusChannel; loadMicrotubuleChannel; loadERChannel;

    thresholdAllChannels

    [tmpnames, feats, slfnames] = fg(protstruct.channel_fg, nucstruct.channel_fg, tubstruct.channel_fg, erstruct.channel_fg, maskstruct.channel, anti, prot_num);
    if ~isempty(tmpnames)
       names = tmpnames;
    end
    if ~exist('names','var')
       names = [];
    end

  case 'refColocal'
    tmpallfeats = []; tmpallnames = []; tmpallslfnames = [];

    %'mutualInfo'
    loadNucleusChannel; loadMicrotubuleChannel; loadERChannel; 
    
    sprot = size(protstruct.channel);
    nuc_re = reshape(nucstruct.channel,[sprot(1)*sprot(2) 1]);
    tub_re = reshape(tubstruct.channel,[sprot(1)*sprot(2) 1]);
    er_re = reshape(erstruct.channel,[sprot(1)*sprot(2) 1]);

    commonScriptMutualInformation_ref

    tmpallfeats = [tmpallfeats,feats(:)'];
    tmpallnames = [tmpallnames,names];
    tmpallslfnames = [tmpallslfnames,slfnames];
    
    %'overlap'
    loadNucleusChannel; loadMicrotubuleChannel; loadERChannel;

    thresholdAllChannels

    tmp_nuc = nucstruct.channel;
    tmp_tub = tubstruct.channel;
    tmp_er = erstruct.channel;
    tmp_nuc_fg = nucstruct.channel_fg;
    tmp_tub_fg = tubstruct.channel_fg;
    tmp_er_fg = erstruct.channel_fg;

    commonScriptOverlap_ref

    tmpallfeats = [tmpallfeats,feats(:)'];
    tmpallnames = [tmpallnames,names];
    tmpallslfnames = [tmpallslfnames,slfnames];

    %'texture'
    prot = nucstruct.channel;
    commonScriptTexture
    tmpallfeats = [tmpallfeats,feats(:)'];
    tmpallnames = [tmpallnames,names];
    tmpallslfnames = [tmpallslfnames,slfnames];

    prot = tubstruct.channel;
    commonScriptTexture
    tmpallfeats = [tmpallfeats,feats(:)'];
    tmpallnames = [tmpallnames,names];
    tmpallslfnames = [tmpallslfnames,slfnames];

    prot = erstruct.channel;
    commonScriptTexture
    tmpallfeats = [tmpallfeats,feats(:)'];
    tmpallnames = [tmpallnames,names];
    tmpallslfnames = [tmpallslfnames,slfnames];

    prot = abs(nucstruct.channel-tubstruct.channel);
    commonScriptTexture
    tmpallfeats = [tmpallfeats,feats(:)'];
    tmpallnames = [tmpallnames,names];
    tmpallslfnames = [tmpallslfnames,slfnames];

    prot = abs(nucstruct.channel-erstruct.channel);
    commonScriptTexture
    tmpallfeats = [tmpallfeats,feats(:)'];
    tmpallnames = [tmpallnames,names];
    tmpallslfnames = [tmpallslfnames,slfnames];

    prot = abs(tubstruct.channel-erstruct.channel);
    commonScriptTexture
    tmpallfeats = [tmpallfeats,feats(:)'];
    tmpallnames = [tmpallnames,names];
    tmpallslfnames = [tmpallslfnames,slfnames];

    %
    feats = tmpallfeats;
    names = tmpallnames;
    slfnames = tmpallslfnames;
    clear tmpallfeats tmpallnames tmpallslfnames

  case 'refColocalx2'
    tmpallfeats = []; tmpallnames = []; tmpallslfnames = [];

    %'mutualInfox2'
    loadNucleusChannel; loadMicrotubuleChannel; loadERChannel; 
    
    downsampleAllChannels

    sprot = size(protstruct.downsampled2x);
    nuc_re = reshape(nucstruct.downsampled2x,[sprot(1)*sprot(2) 1]);
    tub_re = reshape(tubstruct.downsampled2x,[sprot(1)*sprot(2) 1]);
    er_re = reshape(erstruct.downsampled2x,[sprot(1)*sprot(2) 1]);

    commonScriptMutualInformation_ref

    renameDownsampled

    tmpallfeats = [tmpallfeats,feats(:)'];
    tmpallnames = [tmpallnames,names];
    tmpallslfnames = [tmpallslfnames,slfnames];
    
    %'overlapx2'
    loadNucleusChannel; loadMicrotubuleChannel; loadERChannel;

    downsampleAllChannels

    thresholdDownsampled2xAllChannels

    tmp_nuc = nucstruct.downsampled2x;
    tmp_tub = tubstruct.downsampled2x;
    tmp_er = erstruct.downsampled2x;
    tmp_nuc_fg = nucstruct.downsampled2x_fg;
    tmp_tub_fg = tubstruct.downsampled2x_fg;
    tmp_er_fg = erstruct.downsampled2x_fg;

    commonScriptOverlap_ref

    renameDownsampled

    tmpallfeats = [tmpallfeats,feats(:)'];
    tmpallnames = [tmpallnames,names];
    tmpallslfnames = [tmpallslfnames,slfnames];

    %'texturex2'
    downsampleNucleusChannel
    prot = nucstruct.downsampled2x;
    commonScriptTexture
    renameDownsampled
    tmpallfeats = [tmpallfeats,feats(:)'];
    tmpallnames = [tmpallnames,names];
    tmpallslfnames = [tmpallslfnames,slfnames];

    downsampleMicrotubuleChannel
    prot = tubstruct.downsampled2x;
    commonScriptTexture
    renameDownsampled
    tmpallfeats = [tmpallfeats,feats(:)'];
    tmpallnames = [tmpallnames,names];
    tmpallslfnames = [tmpallslfnames,slfnames];

    downsampleERChannel
    prot = erstruct.downsampled2x;
    commonScriptTexture    
    renameDownsampled
    tmpallfeats = [tmpallfeats,feats(:)'];
    tmpallnames = [tmpallnames,names];
    tmpallslfnames = [tmpallslfnames,slfnames];

    downsampleNucleusChannel; downsampleMicrotubuleChannel;
    prot = abs(nucstruct.downsampled2x-tubstruct.downsampled2x);
    commonScriptTexture
    renameDownsampled
    tmpallfeats = [tmpallfeats,feats(:)'];
    tmpallnames = [tmpallnames,names];
    tmpallslfnames = [tmpallslfnames,slfnames];

    downsampleNucleusChannel; downsampleERChannel;
    prot = abs(nucstruct.downsampled2x-erstruct.downsampled2x);
    commonScriptTexture
    renameDownsampled
    tmpallfeats = [tmpallfeats,feats(:)'];
    tmpallnames = [tmpallnames,names];
    tmpallslfnames = [tmpallslfnames,slfnames];

    downsampleMicrotubuleChannel; downsampleERChannel;
    prot = abs(tubstruct.downsampled2x-erstruct.downsampled2x);
    commonScriptTexture
    renameDownsampled
    tmpallfeats = [tmpallfeats,feats(:)'];
    tmpallnames = [tmpallnames,names];
    tmpallslfnames = [tmpallslfnames,slfnames];

    %
    feats = tmpallfeats;
    names = tmpallnames;
    slfnames = tmpallslfnames;
    clear tmpallfeats tmpallnames tmpallslfnames


  otherwise
    error('improper feature set specified');
end
