
tmp_idx = find((~nuc_re)&(~tub_re)&(~er_re));
nuc_re(tmp_idx) = [];
tub_re(tmp_idx) = [];
er_re(tmp_idx) = [];

if isempty(nuc_re) || isempty(tub_re) || isempty(er_re)
   feats = zeros(1,30);    
else
mi = double(min(nuc_re));    ma = double(max(nuc_re));
nuc_re8 = round( (double(nuc_re)-mi) * 7/(ma-mi)); nuc_re8(isnan(nuc_re8)) = 0;
nuc_re16 = round( (double(nuc_re)-mi) * 15/(ma-mi)); nuc_re16(isnan(nuc_re16)) = 0;
nuc_re32 = round( (double(nuc_re)-mi) * 31/(ma-mi)); nuc_re32(isnan(nuc_re32)) = 0;
nuc_re64 = round( (double(nuc_re)-mi) * 63/(ma-mi)); nuc_re64(isnan(nuc_re64)) = 0;
nuc_re128 = round( (double(nuc_re)-mi) * 127/(ma-mi)); nuc_re128(isnan(nuc_re128)) = 0;

mi = double(min(tub_re));    ma = double(max(tub_re));
tub_re8 = round( (double(tub_re)-mi) * 7/(ma-mi)); tub_re8(isnan(tub_re8)) = 0;
tub_re16 = round( (double(tub_re)-mi) * 15/(ma-mi)); tub_re16(isnan(tub_re16)) = 0;
tub_re32 = round( (double(tub_re)-mi) * 31/(ma-mi)); tub_re32(isnan(tub_re32)) = 0;
tub_re64 = round( (double(tub_re)-mi) * 63/(ma-mi)); tub_re64(isnan(tub_re64)) = 0;
tub_re128 = round( (double(tub_re)-mi) * 127/(ma-mi)); tub_re128(isnan(tub_re128)) = 0;

mi = double(min(er_re));    ma = double(max(er_re));
er_re8 = round( (double(er_re)-mi) * 7/(ma-mi)); er_re8(isnan(er_re8)) = 0;
er_re16 = round( (double(er_re)-mi) * 15/(ma-mi)); er_re16(isnan(er_re16)) = 0;
er_re32 = round( (double(er_re)-mi) * 31/(ma-mi)); er_re32(isnan(er_re32)) = 0;
er_re64 = round( (double(er_re)-mi) * 63/(ma-mi)); er_re64(isnan(er_re64)) = 0;
er_re128 = round( (double(er_re)-mi) * 127/(ma-mi)); er_re128(isnan(er_re128)) = 0;


feats1 = [mutualinformation( [tub_re8 nuc_re8]) ...
          mutualinformation( [tub_re16 nuc_re16]) ...
          mutualinformation( [tub_re32 nuc_re32]) ...
          mutualinformation( [tub_re64 nuc_re64]) ...
          mutualinformation( [tub_re128 nuc_re128])];


feats2 = [mutualinformation( [er_re8 tub_re8]) ...
          mutualinformation( [er_re16 tub_re16]) ...
          mutualinformation( [er_re32 tub_re32]) ...
          mutualinformation( [er_re64 tub_re64]) ...
          mutualinformation( [er_re128 tub_re128])];

feats3 = [mutualinformation( [nuc_re8 er_re8]) ...
          mutualinformation( [nuc_re16 er_re16]) ...
          mutualinformation( [nuc_re32 er_re32]) ...
          mutualinformation( [nuc_re64 er_re64]) ...
          mutualinformation( [nuc_re128 er_re128])];

feats4 = [corr2( tub_re8, nuc_re8), ...
          corr2( tub_re16, nuc_re16), ...
          corr2( tub_re32, nuc_re32), ...
          corr2( tub_re64, nuc_re64), ...
          corr2( tub_re128, nuc_re128)];

feats5 = [corr2( er_re8, tub_re8), ...
          corr2( er_re16, tub_re16), ...
          corr2( er_re32, tub_re32), ...
          corr2( er_re64, tub_re64), ...
          corr2( er_re128, tub_re128)];

feats6 = [corr2( nuc_re8, er_re8), ...
          corr2( nuc_re16, er_re16), ...
          corr2( nuc_re32, er_re32), ...
          corr2( nuc_re64, er_re64), ...
          corr2( nuc_re128, er_re128)];

feats = [feats1 feats2 feats3 feats4 feats5 feats6];
end

%{
names = {'nuc:mutual_information_8','nuc:correlation_8', ...
         'nuc:mutual_information_16','nuc:correlation_16', ...
         'nuc:mutual_information_32','nuc:correlation_32', ...
         'nuc:mutual_information_64','nuc:correlation_64', ...
         'nuc:mutual_information_128','nuc:correlation_128', ...
         'tub:mutual_information_8','tub:correlation_8', ...
         'tub:mutual_information_16','tub:correlation_16', ...
         'tub:mutual_information_32','tub:correlation_32', ...
         'tub:mutual_information_64','tub:correlation_64', ...
         'tub:mutual_information_128','tub:correlation_128', ...
         'er:mutual_information_8','er:correlation_8', ...
         'er:mutual_information_16','er:correlation_16', ...
         'er:mutual_information_32','er:correlation_32', ...
         'er:mutual_information_64','er:correlation_64', ...
         'er:mutual_information_128','er:correlation_128'};
%}
names = {'ref:mutual_information_8','ref:mutual_information_16','ref:mutual_information_32','ref:mutual_information_64','ref:mutual_information_128',...
         'ref:mutual_information_8','ref:mutual_information_16','ref:mutual_information_32','ref:mutual_information_64','ref:mutual_information_128',...
         'ref:mutual_information_8','ref:mutual_information_16','ref:mutual_information_32','ref:mutual_information_64','ref:mutual_information_128',...
         'ref:correlation_8','ref:correlation_16','ref:correlation_32','ref:correlation_64','ref:correlation_128',...
         'ref:correlation_8','ref:correlation_16','ref:correlation_32','ref:correlation_64','ref:correlation_128',...
         'ref:correlation_8','ref:correlation_16','ref:correlation_32','ref:correlation_64','ref:correlation_128'};


slfnames = repmat({''},[1 length(names)]);
