% function setCV( dtype, ftype, Nfolds)
clear

% load data/tmp/stainfeatures_Adrenal_gland
% zed = allfeatures;

boolvar = 0;
if exist('Nfolds','var')
    boolvar = 1;
end

if ~exist('dtype','var')
    dtype = 'field';
    % dtype = 'tile';
end
if ~exist('ftype','var')
    ftype = 'Adrenal_gland';
    ftype = 'multi';
end

rootdir = 'data/tmp/';
load([rootdir dtype 'features_' ftype '.mat']);

prefiltering2

Ninit = 2;
N = 2;
trainidx{1} = 1:2:length(classlabels);
trainidx{2} = 2:2:length(classlabels);
testidx{1} = 2:2:length(classlabels);
testidx{2} = 1:2:length(classlabels);


if ~exist('Nfolds','var')
    Nfolds = 1:N;
end


U = unique(classlabels);

c = 2.^(1:1:10);
g = 2.^(-10:1:6);

c = 2.^(1:1:10);
g = 2.^(-5:1:4);

c = 2.^(1:1:9);
g = 2.^(-2:1:5);

c = 2.^(2:2:12);
g = 2.^(0:1:8);

% c = [4 8];
% g = [1 2];

predlabels = zeros(length(classlabels),1);
allweights = zeros(length(classlabels),length(U));
committee = [];
allfeatures = double(allfeatures);

for i=Nfolds
  disp(['evaluating fold: ' num2str(i)]); 

    trainind = trainidx{i};
    testind = testidx{i};

    traindata = allfeatures( trainind,:);
    testdata = allfeatures( testind,:);
    
    trainlabels = classlabels(trainind);
    testlabels = classlabels(testind);

    [traindata, testdata, mu, st] = standardizeFeatures( traindata, testdata);

    % normalizing
    traindata = normalizeFeatures( traindata);
    testdata = normalizeFeatures( testdata);
    
    idx = featureSelection( traindata, trainlabels, 'sda', [num2str(i) '_' dtype '_' ftype])

    wopt = classweights( trainlabels);
    options = ['-s 0 -t 2 -c 4096 -g 128 -b 1 ' wopt];
%     options = parameterEstimationSVM( trainlabels, traindata(:,idx), c, g, wopt)

    model = svmtrain( trainlabels, traindata(:,idx), options);
    [predict_label accuracy weights] = svmpredict( testlabels, testdata(:,idx), model, '-b 1');

    [o1 o2 o3 o4] = conmatrix( testlabels, predict_label)

    committee(i).model = model;
    committee(i).idx_feat = idx;
    committee(i).options = options;
    committee(i).mu = mu;
    committee(i).st = st;
    
    [a ind] = max(weights,[],2);
    predlabels(testind) = model.Label(ind);
    allweights(testind,model.Label) = weights;
end
[cc uu dd ww] = conmatrix( classlabels, predlabels);
round(1000*dd)/10

Nstr = [];
for i=1:length(Nfolds)
    Nstr = [Nstr num2str(Nfolds(i)) '_'];
end
Nstr(end) = [];

if boolvar
    save([rootdir 'svm' dtype '_' ftype '_' Nstr '.mat'], 'allweights','committee');
else
    save([rootdir 'svm' dtype '_' ftype '.mat'], 'allweights','committee');
end


[protlabels,predlabels,proteins,newallweights] = ...
    voteAcrossProtein( allweights, classlabels, antibodyids);

[cc uu dd ww] = conmatrix( protlabels, predlabels);
cc
round(1000*dd)/10

save tmpo1
