function trainclassif( dtype, ftype, RSE)
% clear

boolvar = 0;
if ~exist('RSE','var')
    RSE = 300;
end

if ~exist('dtype','var')
    dtype = 'field';
end

if ~exist('ftype','var')
    ftype = 'multi';
end

rootdir = 'data/tmp/';
load([rootdir dtype 'features_' ftype '.mat']);

%%%%%%%%%%%%%%%%%%%%%%%

allfeatures(:,1:4) = [];
names(1:4) = [];

ind = 1:size(allfeatures,2);
allfeatures = allfeatures(:,ind);
names = names(ind);


[idx c] = find(isnan(allfeatures));
allfeatures(idx,:) = [];
classlabels(idx) = [];
antibodyids(idx) = [];
tissuenames(idx) = [];
imagelist(idx) = [];

if 1==1
% TRUNCATE
[tissues ii tissuelabels] = unique(tissuenames);
abids2 = antibodyids;
% abids2 = antibodyids +100000*tissuelabels;

TN = 5;
keepidx = truncatedataset( classlabels, abids2, TN, RSE);
testallfeatures = allfeatures;
testclasslabels = classlabels;
testantibodyids = antibodyids;
testimagelist = imagelist;
testallfeatures(keepidx,:) = [];
testclasslabels(keepidx) = [];
testantibodyids(keepidx) = [];
testimagelist(keepidx) = [];

allfeatures = allfeatures(keepidx,:);
tissuenames = tissuenames(keepidx);
antibodyids = antibodyids(keepidx);
classlabels = classlabels(keepidx);
%%%%%%
end




idx = find(strcmp(classes,'Nucleus'));
idx = find(testclasslabels==idx);
testallfeatures(idx,:) = [];
testclasslabels(idx) = [];
testantibodyids(idx) = [];
testimagelist(idx) = [];
idx = find(strcmp(classes,'Peroxisome'));
idx = find(testclasslabels==idx);
testallfeatures(idx,:) = [];
testclasslabels(idx) = [];
testantibodyids(idx) = [];
testimagelist(idx) = [];
idx = find(strcmp(classes,'Intermediate filament'));
idx = find(testclasslabels==idx);
testallfeatures(idx,:) = [];
testclasslabels(idx) = [];
testantibodyids(idx) = [];
testimagelist(idx) = [];


idx = find(strcmp(classes,'Nucleus'));
idx = find(classlabels==idx);
allfeatures(idx,:) = [];
classlabels(idx) = [];
antibodyids(idx) = [];
tissuenames(idx) = [];
imagelist(idx) = [];
idx = find(strcmp(classes,'Peroxisome'));
idx = find(classlabels==idx);
allfeatures(idx,:) = [];
classlabels(idx) = [];
antibodyids(idx) = [];
tissuenames(idx) = [];
imagelist(idx) = [];
idx = find(strcmp(classes,'Intermediate filament'));
idx = find(classlabels==idx);
allfeatures(idx,:) = [];
classlabels(idx) = [];
antibodyids(idx) = [];
tissuenames(idx) = [];
imagelist(idx) = [];

testclasslabels = classes(testclasslabels);
[testclasses ii testclasslabels] = unique(testclasslabels);

classlabels = classes(classlabels);
[classes ii classlabels] = unique(classlabels);

%%%%%%%%%%%%%%%%%%%%%%%


c = 2.^(2:2:12);
g = 2.^(0:1:8);

committee = [];
allfeatures = double(allfeatures);
testallfeatures = double(testallfeatures);

trainlabels = classlabels;
testlabels = testclasslabels;
[traindata, testdata, mu, st] = standardizeFeatures( allfeatures, testallfeatures);
traindata = normalizeFeatures( traindata);
testdata = normalizeFeatures( testdata);
    
idx = featureSelection( traindata, trainlabels, 'sda', [num2str(i) '_' dtype '_' ftype '_' num2str(RSE)])

wopt = classweights( trainlabels);
options = parameterEstimationSVM( trainlabels, traindata(:,idx), c, g, wopt)


model = svmtrain( trainlabels, traindata(:,idx), options);
[predict_label accuracy weights] = svmpredict( testlabels, testdata(:,idx), model, '-b 1');

committee.model = model;
committee.idx_feat = idx;
committee.options = options;
committee.mu = mu;
committee.st = st;

[a ind] = max(weights,[],2);
weights(:,model.Label) = weights;


save([rootdir 'svmclassif' dtype '_' ftype '_' num2str(RSE) '.mat'],'weights','testantibodyids', 'testlabels','predict_label','testimagelist','classes');
