function setCV( dtype, ftype, Nfolds)
% clear

% load data/tmp/stainfeatures_Adrenal_gland
% zed = allfeatures;

boolvar = 0;
if exist('Nfolds','var')
    boolvar = 1;
end

if ~exist('dtype','var')
    dtype = 'field';
    % dtype = 'tile';
end
if ~exist('ftype','var')
    ftype = 'Adrenal_gland';
    % ftype = 'multi';
end

rootdir = 'data/tmp/';
load([rootdir dtype 'features_' ftype '.mat']);

prefiltering


% antibodyids = [1:1:length(classlabels)]';
[tissues ii tissuelabels] = unique(tissuenames);
abids2 = antibodyids;
% abids2 = antibodyids +100000*tissuelabels;


Ninit = 5;
[trainidx,testidx, protlabels,N] = splitbyproteins( classlabels, abids2, Ninit);

% splits = partition( classlabels, N,13);
% [trainidx,testidx] = partedsets(splits);


if ~exist('Nfolds','var')
    Nfolds = 1:N;
end


U = unique(classlabels);

c = 2.^(1:1:10);
g = 2.^(-10:1:6);

c = 2.^(1:1:10);
g = 2.^(-5:1:4);

c = 2.^(1:1:9);
g = 2.^(-2:1:5);

c = 2.^(2:2:8);
g = 2.^(0:2:6);

% c = 8;
% g = 0.25;

predlabels = zeros(length(classlabels),1);
allweights = zeros(length(classlabels),length(U));
committee = [];
allfeatures = double(allfeatures);

for i=Nfolds
  disp(['evaluating fold: ' num2str(i)]); 
    trainind = find(ismember(protlabels,trainidx{i}));
    testind = find(ismember(protlabels,testidx{i}));

%     trainind = trainidx{i};
%     testind = testidx{i};

    traindata = allfeatures( trainind,:);
    testdata = allfeatures( testind,:);
    
    trainlabels = classlabels(trainind);
    testlabels = classlabels(testind);

    [traindata, testdata, mu, st] = standardizeFeatures( traindata, testdata);

    % normalizing
    traindata = normalizeFeatures( traindata);
    testdata = normalizeFeatures( testdata);

    trainprots = antibodyids(trainind);
    traintissuenames = tissuenames(trainind);
    
    [traintissues trainii traintissuelabels] = unique(traintissuenames);
    trainabids2 = trainprots;
    % trainabids2 = trainprots+100000*traintissuelabels;
    [traintrainidx, traintestidx, trainprotlabels, trainN] = splitbyproteins( trainlabels, trainabids2, 3);%Ninit-1);

    idx = featureSelection( traindata, trainlabels, 'sda', [num2str(i) '_' dtype '_' ftype])


    all_acc = zeros(length(traintrainidx),length(c),length(g));
    for zed = 1:length(traintrainidx)
        traintrainind = find(ismember(trainprotlabels,traintrainidx{zed}));
        traintestind = find(ismember(trainprotlabels,traintestidx{zed}));

        traintraindata = traindata( traintrainind,:);
        traintestdata = traindata( traintestind,:);
    
        traintrainlabels = trainlabels(traintrainind);
        traintestlabels = trainlabels(traintestind);

%         idx = 1:size(allfeatures,2);

        ma = 0;
        wopt = classweights( traintrainlabels);
        for j=1:length(c)
            for k=1:length(g)
                options = ['-s 0 -t 2 -c ' num2str(c(j)) ' -g ' num2str(g(k)) ' -b 0 ' wopt];
                
                model = svmtrain( traintrainlabels, traintraindata(:,idx), options);
                [predict_label accuracy weights] = svmpredict( traintestlabels, traintestdata(:,idx), model, '-b 0');
                [ccc uuu ddd www] = conmatrix(traintestlabels, predict_label);
                all_acc(zed,j,k) = www;
            end
        end
    end
    s(:,:) = mean(all_acc,1);
    [row col] = find(s==max(s(:)));
    
    if length(row)>1
        row = row(floor(length(row)/2));
        col = col(floor(length(col)/2));
    end
    wopt = classweights( trainlabels);
    options = ['-s 0 -t 2 -c ' num2str(c(row)) ' -g ' num2str(g(col)) ' -b 1 ' wopt];


    model = svmtrain( trainlabels, traindata(:,idx), options);
    [predict_label accuracy weights] = svmpredict( testlabels, testdata(:,idx), model, '-b 1');

    [o1 o2 o3 o4] = conmatrix( testlabels, predict_label)

    committee(i).model = model;
    committee(i).idx_feat = idx;
    committee(i).options = options;
    committee(i).mu = mu;
    committee(i).st = st;
    
    [a ind] = max(weights,[],2);
    predlabels(testind) = model.Label(ind);
    allweights(testind,model.Label) = weights;
end
[cc uu dd ww] = conmatrix( classlabels, predlabels)

Nstr = [];
for i=1:length(Nfolds)
    Nstr = [Nstr num2str(Nfolds(i)) '_'];
end
Nstr(end) = [];

if boolvar
    save([rootdir 'svm' dtype '_' ftype '_' Nstr '.mat'], 'allweights','committee');
else
    save([rootdir 'svm' dtype '_' ftype '.mat'], 'allweights','committee');
end

[protlabels,predlabels,proteins,newallweights] = ...
    modeAcrossProtein( allweights, classlabels, antibodyids);

[cc uu dd ww] = conmatrix( protlabels, predlabels);
cc
dd



[protlabels,predlabels,proteins,newallweights] = ...
    voteAcrossProtein( allweights, classlabels, antibodyids);

[cc uu dd ww] = conmatrix( protlabels, predlabels);
cc
dd

save tmpo1
