function results( allweights, classlabels, classes, imagelabels, antibodyids, savecsv, savefigure)


for i=1:length(classes)
    tmp_idx = find(classes{i}==',');
    classes{i}(tmp_idx) = '/';
end

addpath lib/results
addpath lib/system

[val predlabels] = max(allweights,[],2);
[C U D W] = conmatrix( classlabels, predlabels);

Ntot = sum(C(:));
Ncorr = U*Ntot;

D = round(D*1000)/10;
U = round(U*1000)/10;
W = round(W*1000)/10;

classes;

fid = fopen(savecsv,'w');

if isempty( imagelabels)
    fwrite(fid,['Field level confusion matrix,' char(10)]);
else
    fwrite(fid,['Single cell confusion matrix,' char(10)]);
end
fwrite(fid,',');
for i=1:length(classes)
    fwrite(fid,classes{i});
    fwrite(fid,',');
end
fwrite(fid,['#samples,' char(10)]);

for i=1:length(classes)
    fwrite(fid,classes{i});
    fwrite(fid,',');
    for j=1:length(classes)
        fwrite(fid,num2str(D(i,j)));
        fwrite(fid,',');
    end
    fwrite(fid, [num2str(sum(C(i,:))) ',' char(10)]);
end
fwrite(fid,['Accuracy,' num2str(U) ',' char(10)]);
fwrite(fid,['Class weighted accuracy,' num2str(W) ',' char(10)]);




fwrite(fid,[char(10) char(10)]);
fwrite(fid,['Protein level confusion matrix,' char(10)]);
proteins = unique(antibodyids);
predlabels = zeros(size(proteins));
protlabels = zeros(size(proteins));
for i=1:length(proteins)
    idx = find(proteins(i)==antibodyids);
    weights = sum(allweights(idx,:),1);
    [a label] = max(weights,[],2);
    
    predlabels(i) = label;
    
    protlabels(i) = mode(classlabels(idx));
end

[C U D W] = conmatrix( protlabels,predlabels);

D = round(D*1000)/10;
U = round(U*1000)/10;
W = round(W*1000)/10;
fwrite(fid,',');
for i=1:length(classes)
    fwrite(fid,classes{i});
    fwrite(fid,',');
end
fwrite(fid,['#samples,' char(10)]);

for i=1:length(classes)
    fwrite(fid,classes{i});
    fwrite(fid,',');
    for j=1:length(classes)
        fwrite(fid,num2str(D(i,j)));
        fwrite(fid,',');
    end
    fwrite(fid, [num2str(sum(C(i,:))) ',' char(10)]);
end
fwrite(fid,['Accuracy,' num2str(U) ',' char(10)]);
fwrite(fid,['Class weighted accuracy,' num2str(W) ',' char(10)]);







[val predlabels] = max(allweights, [], 2);
[s ind] = sort(val);

pr2 = zeros(length(s),1);
re = zeros(length(s),1);
pr = zeros(length(s),1);
numcl = zeros(length(s),1);
for i=length(s):-1:1
    prl = predlabels(ind(i:end));
    cll = classlabels(ind(i:end))';
    % [ccc uuu ddd www] = conmatrix( classlabels(ind(i:end)), predlabels(ind(i:end)));
    % pr2(i) = www;
    % pr(i) = uuu;
    % re(i) = uuu*length(prl)/Ntot;
    
    % numcl(i) = length(find(sum(ccc,2)));
    
    % if numcl(i)==9 & numcl(i+1)==8
    %     [ccc uuu ddd www] = conmatrix( classlabels(ind(i-1:end)), predlabels(ind(i-1:end)))
    %     re(i)
    % end

    pr(i) = sum(prl'==cll)/length(prl);
    re(i) = pr(i)*length(prl)/Ntot;
end

% whos re
% pr = pr2(numcl==9);
% re = re(numcl==9);

if 1==2
indo_tmp = find(re>0.55);
indo_tmp = indo_tmp(end);
indzed = ind(indo_tmp:end);
[cc uu dd ww] = conmatrix( classlabels(indzed),predlabels(indzed));
save('tmpo1.mat','indzed');
sum(cc,2)
%uu
dd
% ww
end

xmin = min(re)*100;
xmax = max(re)*100;
xmax = xmax + 0.1*(xmax-xmin);
ymin = min(pr)*100;
ymax = max(pr)*100;
ymax = ymax + 0.1*(ymax-ymin);

close('all');
figure1 = figure('Color',[1 1 1],'Position', [100 100 650 650]);
axes('Parent',figure1,'FontSize',28,'LineWidth',3, 'XTick',[0 0.2 0.4 0.6 0.8 1]*100, 'YTick',[0 0.1 0.2 0.3 0.4 0.5 0.6 0.7 0.8 0.9 1]*100, 'Position',[.20 .20 .75 .75]);
xpos = [(xmax-xmin)/2+xmin ymin-(ymax-ymin)*.15];
ypos = [-5 (ymax-ymin)/2+ymin];

plot(re*100,pr*100,'k^','LineWidth',2,'Color',[0 0 0]);
xlabel('Recall (%)','FontSize',32,'Position',xpos);% ,'FontName','Kartika');
ylabel('Precision (%)','FontSize',32,'Position',ypos);% ,'FontName','Kartika');
axis([xmin xmax ymin ymax]);

print('-f1', '-depsc', savefigure);

if isempty( imagelabels)
    fclose('all');
    return
end



% classif by images
imagelist = imagelabels;
[Ui ii imagelabels] = unique(imagelist);
Ui = unique(imagelabels);
zed = zeros(length(imagelist),1);
ppredlabels = zeros(length(imagelist),1);
pclasslabels = zeros(length(imagelist),1);
allvals = zeros(length(Ui), size(allweights,2));
for i=1:length(Ui)
    idx = find(imagelabels==Ui(i));
    val = prod(allweights(idx,:),1);
    allvals(i,:) = val;
    [a nlabel] = max(val);
    ppredlabels(i) = nlabel;
    pclasslabels(i) = classlabels(idx(1));
end

[C U D W] = conmatrix( pclasslabels, ppredlabels);
Ntot = sum(C(:));
Ncorr = U*Ntot;

D = round(D*1000)/10;
U = round(U*1000)/10;
W = round(W*1000)/10;


fwrite(fid,[char(10) char(10) char(10)]);
fwrite(fid,['Field level confusion matrix,' char(10)]);
fwrite(fid,',');
for i=1:length(classes)
    fwrite(fid,classes{i});
    fwrite(fid,',');
end
fwrite(fid,['#samples,' char(10)]);

for i=1:length(classes)
    fwrite(fid,classes{i});
    fwrite(fid,',');
    for j=1:length(classes)
        fwrite(fid,num2str(D(i,j)));
        fwrite(fid,',');
    end
    fwrite(fid, [num2str(sum(C(i,:))) ',' char(10)]);
end
fwrite(fid,['Accuracy,' num2str(U) ',' char(10)]);
fwrite(fid,['Class weighted accuracy,' num2str(W) ',' char(10)]);



[val predlabels] = max(allvals, [], 2);
[s ind] = sort(val);

re = zeros(length(s),1);
pr = zeros(length(s),1);
for i=length(s):-1:1
    prl = ppredlabels(ind(i:end));
    cll = pclasslabels(ind(i:end));
    pr(i) = sum(prl==cll)/length(prl);
    re(i) = pr(i)*length(prl)/Ntot;
end

xmin = min(re)*100;
xmax = max(re)*100;
xmax = xmax + 0.1*(xmax-xmin);
ymin = min(pr)*100;
ymax = max(pr)*100;
ymax = ymax + 0.1*(ymax-ymin);

close('all');
figure1 = figure('Color',[1 1 1],'Position', [100 100 650 650]);
axes('Parent',figure1,'FontSize',28,'LineWidth',3, 'XTick',[0 0.2 0.4 0.6 0.8 1]*100, 'YTick',[0 0.1 0.2 0.3 0.4 0.5 0.6 0.7 0.8 0.9 1]*100, 'Position',[.20 .20 .75 .75]);
xpos = [(xmax-xmin)/2+xmin ymin-(ymax-ymin)*.15];
ypos = [-5 (ymax-ymin)/2+ymin];

plot(re*100,pr*100,'k^','LineWidth',2,'Color',[0 0 0]);
xlabel('Recall (%)','FontSize',32,'Position',xpos);% ,'FontName','Kartika');
ylabel('Precision (%)','FontSize',32,'Position',ypos);% ,'FontName','Kartika');
axis([xmin xmax ymin ymax]);

savefigure = findreplacestring( savefigure, '.', '_voting.');
print('-f1', '-depsc', savefigure);



fclose(fid);
return
