function  [re,pr,renw,prnw,resingle,prsingle] = makePRcurve_mix2( classlabels, allweights, classes,ftstr, numSingle)

if exist('numSingle','var')
    Ntot = numSingle;
else
    Ntot = length(classlabels);
end


[vals,predlabels] = max(allweights,[],2);

zed = 1;
if zed==1
    [vals,predlabels] = max(allweights,[],2);
    [s ind] = sort(vals);
else
    ind = 0:.001:0.999;
end

re = zeros(length(ind),1);
pr = zeros(length(ind),1);
renw = zeros(length(ind),1);
prnw = zeros(length(ind),1);
for i=1:length(ind)
    if zed==1
        idx = ind(i:end);
    else
        idx = find(vals>=ind(i));
    end

    [numCorrect,numHalfCorrect,numWrong] = mixedBreakdown( classlabels(idx), predlabels(idx), classes);

    re(i) = numCorrect/Ntot;
    pr(i) = numCorrect/length(idx);
    renw(i) = (numCorrect+numHalfCorrect)/Ntot;
    prnw(i) = (numCorrect+numHalfCorrect)/(numCorrect+numHalfCorrect+numWrong);
    %resingle(i) = numCorrect/Numsingle;
    %prsingle(i) = numCorrect/length(find(ismember(classlabels(idx),idx_single)));
end


%if only consider single patterns...
idx_single = [];
for i = 1:length(classes)
    if isempty(strfind(classes{i},','))
       idx_single = [idx_single;i];
    end
end
Numsingle = length(find(ismember(classlabels,idx_single)));

tmpidx = find(ismember(classlabels,idx_single));
classlabels = classlabels(tmpidx);
allweights = allweights(tmpidx,:); %

[vals,predlabels] = max(allweights,[],2);

zed = 1;
if zed==1
    [vals,predlabels] = max(allweights,[],2);
    [s ind] = sort(vals);
else
    ind = 0:.001:0.999;
end

resingle = zeros(length(ind),1);
prsingle = zeros(length(ind),1);
for i=1:length(ind)
    if zed==1
        idx = ind(i:end);
    else
        idx = find(vals>=ind(i));
    end

    numCorrect = sum(classlabels(idx)==predlabels(idx));

    resingle(i) = numCorrect/Numsingle;
    prsingle(i) = numCorrect/length(idx);
end



%{
tmp_idx = find(pr>0.9);
re(tmp_idx(1))
tmp_idx = find(prnw>0.9);
renw(tmp_idx(1))


re1 = re;
pr1 = pr;
re2 = renw;
pr2 = prnw;

re = [re1; re2];
pr = [pr1; pr2];

xmin = min(re)*100;
xmax = max(re)*100;
xmax = xmax + 0.1*(xmax-xmin);
ymin = min(pr)*100;
ymax = max(pr)*100;
ymax = ymax + 0.1*(ymax-ymin);

close('all');
figure1 = figure('Color',[1 1 1],'Position', [100 100 650 650]);
axes('Parent',figure1,'FontSize',28,'LineWidth',3, 'XTick',[0 0.2 0.4 0.6 0.8 1]*100, 'YTick',[0 0.1 0.2 0.3 0.4 0.5 0.6 0.7 0.8 0.9 1]*100, 'Position',[.20 .20 .75 .75]);
xpos = [(xmax-xmin)/2+xmin ymin-(ymax-ymin)*.15];
ypos = [xmin-(xmax-xmin)/10 (ymax-ymin)/2+ymin];

plot(re1*100,pr1*100,'k-^','LineWidth',2,'Color',[0 0 0]);
hold on;
plot(re2*100,pr2*100,'k-^','LineWidth',2,'Color',[.5 .5 .5]);
xlabel('Recall (%)','FontSize',32,'Position',xpos);
ylabel('Precision (%)','FontSize',32,'Position',ypos);
title(ftstr,'FontSize',32,'Position',[xmax-(xmax-xmin)/5 ymax-(ymax-ymin)/4.5]);
axis([xmin xmax ymin ymax]);

print('-f1', '-depsc', ['PR_' ftstr '.eps']);
%}

