function [re,pr,s,ind] = makeROCcurve( classlabels, allweights, positive, classes, numSingle)

% re: true positive rate, TPR = TP / P = TP / (TP + FN)
% pr: false positive rate, FPR = FP / N = FP / (FP + TN)

[vals,predlabels] = max(allweights,[],2);

if exist('numSingle','var')
    Ntot = numSingle;
else
    Ntot = length(classlabels);
end



zed = 1;
if zed==1
    [vals,predlabels] = max(allweights,[],2);
    [s ind] = sort(vals);
else
    ind = 0:.001:0.999;
end

re = zeros(length(ind),1);
pr = zeros(length(ind),1);
length_P = sum(classlabels==positive);  %%
length_N = length(classlabels)-length_P;
for i=1:length(ind)
    if zed==1
        idx = ind(i:end);
    else
        idx = find(vals>=ind(i));
    end
    
    % [cc uu dd ww] = conmatrix(classlabels(idx),predlabels(idx));
    
    P = sum(classlabels==positive);  
    TP = sum((predlabels(idx)==positive).*(classlabels(idx)==positive));
    N = length(classlabels)-P;
    FP = sum(predlabels(idx)==positive)-TP;
    
    re(i) = TP / P;
    pr(i) = FP / N;

end

