function [classes, classlabels, predlabels, predvals, antibodyids, imagelist] = ...
    mergeClasses( classes, classlabels, predlabels, predvals, antibodyids, imagelist, mpattern)

if ~exist('mpattern','var')
    mpattern = 'cytoplasm';
end

idx = [];
for i=1:length(classes)
    ind = findstr(classes{i},mpattern);
        
    if length(ind)
        idx = [idx; i];
    end
end


ind = find(ismember(classlabels,idx));
ind2 = find(ismember(predlabels,idx));


if isempty(ind)
    return
end

ncn = max(classlabels)+1;




classes{ncn} = ['loc_' mpattern];

classlabels(ind) = ncn;
predlabels(ind2) = ncn;

tmpclasslabels = classlabels;
[classids ii classlabels] = unique(tmpclasslabels);


for i=1:length(classids)
    tmp_idx = find(predlabels==classids(i));
    predlabels(tmp_idx)=-i;
end
predlabels = -predlabels;

classes = classes(classids);




ind = find(predlabels==max(classlabels));

classlabels(ind) = [];
predlabels(ind) = [];
predvals(ind) = [];
antibodyids(ind) = [];
imagelist(ind) = [];
