function [numCorrect,numHalfCorrect,numWrong] = mixedBreakdown( classlabels, predlabels, classes)

[cc uu dd ww] = conmatrix( classlabels, predlabels, length(classes));


comat = zeros(length(classes));
for i=1:length(classes)
    str = classes{i};
    for j=1:length(classes)
        idx = findstr(str, classes{j});
        if ~isempty(idx)
            comat(i,j) = 1;
        end
    end
end

[r c] = find(comat);

numCorrect = eye(size(cc)).*cc;
numCorrect = sum(numCorrect(:));

numHalfCorrect = 0;
for i=1:size(comat,1)
    r = find(comat(i,:));
    numHalfCorrect = numHalfCorrect + sum(cc(i,r));
end
numWrong = length(classlabels) - numHalfCorrect;
numHalfCorrect = numHalfCorrect - numCorrect;

