function results( classlabels, predlabels, val, classes, savecsv, savefigure, antibodyids)



tmp_ind = [];
for i=1:length(classes)
    tmp_idx = find(classes{i}==',');
    classes{i}(tmp_idx) = '/';
    
    if ~isempty(tmp_idx)
        str1 = classes{i}(1:tmp_idx-1);
        str2 = classes{i}(tmp_idx+1:end);
        z1 = find(strcmp(str1,classes));
        z2 = find(strcmp(str2,classes));
        tmp = [i z1 z2];
        if length(tmp)==2
            tmp(end+1) = find(strcmp('loc_nucleus',classes));
        end
        tmp_ind = [tmp_ind; tmp];
    end
end


if 1==1
classlabels1 = classlabels;
classlabels2 = classlabels;
predlabels1 = predlabels;
predlabels2 = predlabels;
for i=1:size(tmp_ind,1)
    tmp_idx = find(classlabels==tmp_ind(i,1) & predlabels==tmp_ind(i,2));
    predlabels1(tmp_idx) = classlabels(tmp_idx);
    tmp_idx = find(classlabels==tmp_ind(i,1) & predlabels==tmp_ind(i,3));
    predlabels1(tmp_idx) = classlabels(tmp_idx);
end
classlabels = [classlabels1; classlabels1];
predlabels = [predlabels1; predlabels2];
val = [val; val];
antibodyids = [antibodyids antibodyids];
end


addpath lib/results
addpath lib/system

[s ind] = sort(val);

[C U D W] = conmatrix( classlabels, predlabels);
D = round(D*1000)/10;
U = round(U*1000)/10;
W = round(W*1000)/10;

Ntot = sum(C(:));


fid = fopen(savecsv,'w');

fwrite(fid,['Confusion matrix,' char(10)]);
fwrite(fid,',');
for i=1:length(classes)
    fwrite(fid,classes{i});
    fwrite(fid,',');
end
fwrite(fid,['#samples,' char(10)]);

for i=1:length(classes)
    fwrite(fid,classes{i});
    fwrite(fid,',');
    for j=1:length(classes)
        fwrite(fid,num2str(D(i,j)));
        fwrite(fid,',');
    end
    fwrite(fid, [num2str(sum(C(i,:))) ',' char(10)]);
end
fwrite(fid,['Accuracy,' num2str(U) ',' char(10)]);
fwrite(fid,['Class weighted accuracy,' num2str(W) ',' char(10)]);

fclose(fid);




pr2 = zeros(length(s),1);
re = zeros(length(s),1);
pr = zeros(length(s),1);
numcl = zeros(length(s),1);
for i=length(s):-1:1
    prl = predlabels(ind(i:end));
    cll = classlabels(ind(i:end))';
    % [ccc uuu ddd www] = conmatrix( classlabels(ind(i:end)), predlabels(ind(i:end)));
    % pr2(i) = www;
    % pr(i) = uuu;
    % re(i) = uuu*length(prl)/Ntot;
    
    % numcl(i) = length(find(sum(ccc,2)));
    
    % if numcl(i)==9 & numcl(i+1)==8
    %     [ccc uuu ddd www] = conmatrix( classlabels(ind(i-1:end)), predlabels(ind(i-1:end)))
    %     re(i)
    % end

    pr(i) = sum(prl'==cll)/length(prl);
    re(i) = pr(i)*length(prl)/Ntot;
end

tmp_idx = find(pr>0.90);
thr = s(tmp_idx(1))

idx = find(val>thr);
[cc uu dd ww] = conmatrix( classlabels(idx),predlabels(idx));
round(cc/2)
uu 
dd
ww
if 1==2
sum(cc,2)/2
sum(sum(eye(size(cc)).*cc))/2

ind = find(classlabels(idx)~=predlabels(idx));

abids = antibodyids(idx(ind));
clids = classlabels(idx(ind));
prids = predlabels(idx(ind));

zed = [];
for i=1:length(abids)
zed = [zed num2str(abids(i)) '   ' classes{clids(i)} '   ' classes{prids(i)} char(10)];
end
zed
end

xmin = min(re)*100;
xmax = max(re)*100;
xmax = xmax + 0.1*(xmax-xmin);
ymin = min(pr)*100;
ymax = max(pr)*100;
ymax = ymax + 0.1*(ymax-ymin);

close('all');
figure1 = figure('Color',[1 1 1],'Position', [100 100 650 650]);
axes('Parent',figure1,'FontSize',28,'LineWidth',3, 'XTick',[0 0.2 0.4 0.6 0.8 1]*100, 'YTick',[0 0.1 0.2 0.3 0.4 0.5 0.6 0.7 0.8 0.9 1]*100, 'Position',[.20 .20 .75 .75]);
xpos = [(xmax-xmin)/2+xmin ymin-(ymax-ymin)*.15];
ypos = [-5 (ymax-ymin)/2+ymin];

plot(re*100,pr*100,'k^','LineWidth',2,'Color',[0 0 0]);
xlabel('Recall (%)','FontSize',32,'Position',xpos);% ,'FontName','Kartika');
ylabel('Precision (%)','FontSize',32,'Position',ypos);% ,'FontName','Kartika');
axis([xmin xmax ymin ymax]);

print('-f1', '-depsc', savefigure);

return
