function [ff,gg] = PGM_DTK(x)

global f Y M D T K

if length(x)~=D*T + D*T*K
   error('Check the dimension of x!');
end

W = reshape(x(1:D*T),[D,T]);
V = reshape(x(D*T+1:end),[D,T,K]);

%A:M*T, row sum to 1
A = exp(f*W);
A = A./repmat(sum(A,2),[1,size(A,2)]);

%B:M*T*K, fiber sum to 1
B = zeros(M,T,K);
for i=1:K
    B(:,:,i) = exp(f*V(:,:,i));
end
B = B./repmat(sum(B,2),[1,size(B,2),1]);

%PCF:M*K
PCF = squeeze(log(sum(repmat(A,[1,1,K]).*B,2))); %

lambdaW = 1;
lambdaV = 1;
%Objective
ff = -sum(sum(Y.*log(PCF))) + lambdaW*norm(W,'fro')^2 + lambdaV*norm(V(:),'fro')^2;

%Gradient
%Q:M*T*K
Q = repmat(A,[1,1,K]).*B-repmat(A.^2,[1,1,K]).*B;
R = repmat(A,[1,1,K]).*B-repmat(A,[1,1,K]).*B.^2;

for i=1:T
    tmp1(:,i,:) = full(Y)./PCF;
end
gg_W = -f'*sum(tmp1.*Q,3) + 2*lambdaW*W;
tmp2 = zeros(D,T,K);
for i=1:K
    tmp2(:,:,i) = -f'*(tmp1(:,:,i).*R(:,:,i));
end
gg_V = tmp2 + 2*lambdaV*V;
gg = [gg_W(:); gg_V(:)];


clear A B W V PCF Q R tmp1 tmp2
