function [codebook, code] = Quantize(X, codebook, kmeans_iter)
%[codebook, code] = Quantize(X, codebook)
% quantize X (n x dim) using the codebook (or K). 
% if codebook is provided, then only returns the code
% if codebook is actually K, then the codebook is estimated using kmeans 
% and both the codebook and the code are returned

if nargin < 3
    kmeans_iter = 50;
end

if isscalar(codebook)
    K = codebook;
    codebook = double(kml(single(X)', K, 3, kmeans_iter, false)');
    if nargout > 1
        code = NNClassify(X, codebook);
    end
else
    codebook = NNClassify(X, codebook);
end
