function [ result, filter ] = RemoveDupEdges( edges, nNode )
% [ result ] = RemoveDupEdges( edges, nNode )
% remove duplicate edges
% each row of edges is an edge
% return unique edges

if nargin < 2
    nNode = max(max(edges(1:min(end,2), :)));
end

code = min(edges(:, 1:2), [], 2)*nNode + max(edges(:, 1:2), [], 2);
filter = ArgUnique(int32(code));
result = edges(filter, :);
