datafile = './data/fandg_single_A431R2.mat';
%datafile = '/home/jieyuel/lib_backup/data/IF_atlas_5/regionfeatures_single_A431R2.mat';

load(datafile, 'f', 'classlabels', 'classes', 'antibodyids', 'allfeatures');


if exist('allfeatures','var')

addpath('/home/jieyuel/lib_backup/lib_Justin/lib/classification');

Nclass = 5;
classlabels = classlabels(:);
classes = classes(:);

allfeatures(isnan(allfeatures)) = 0;
tmpmax = max(allfeatures,[],1);
tmpmin = min(allfeatures,[],1);
tmpidx = find((tmpmax-tmpmin)<=1e-2);
allfeatures(:,tmpidx) = [];

[rows,cols] = find(isnan(allfeatures));
allfeatures(rows,:) = [];
classlabels(rows,:) = [];
antibodyids(rows,:) = [];

%iidx = find(isinf(allfeatures));  %%
%allfeatures(iidx) = sign(allfeatures(iidx)).*realmax('single');
[iidx,iidy] = find(isinf(allfeatures));
allfeatures(:,iidy) = [];

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%delete classes with small number of antibodies.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%class_set=unique(classlabels);
%for i=1:length(class_set)
%c(i)=length(unique(antibodyids(find(classlabels==class_set(i)))));
%end

class_del = [];
class_set = unique(classlabels);
classes_idx = 1:length(classes);
if length(unique(classlabels))<length(classes)
   warning('Some classes are not in the classlabels. Delete them... Check data!');
   tmpind = ~ismember(classes_idx,class_set); %%
   class_del = [class_del,classes_idx(tmpind)];
elseif length(unique(classlabels))>length(classes)
   warning('Some classlabels are not in the classes. Delete them... Problematic and Data-Check recommended!');
   tmpind = ~ismember(class_set,classes_idx); %%
   class_del = [class_del,class_set(tmpind)'];
end

for i=1:length(class_set)
    numc(i)=length(unique(antibodyids(find(classlabels==class_set(i)))));
    if numc(i)<Nclass
       class_del = [class_del,class_set(i)];
    end
end
tmpidx = ismember(classlabels,class_del);
allfeatures(tmpidx,:) = [];
antibodyids(tmpidx) = [];
classlabels(tmpidx) = [];
classes(class_del) = [];
class_del = sort(class_del);
for i=1:length(class_del)
    tmpdex = find(classlabels>class_del(i));
    classlabels(tmpdex) = classlabels(tmpdex)-1;
    class_del = class_del-1;
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
f = allfeatures;

f = double(f); f(isnan(f)) = 0;

tmpmax = max(f,[],1);
tmpmin = min(f,[],1);
tmpidx = find((tmpmax-tmpmin)<=1e-2);
f(:,tmpidx) = [];

[tmpr,tmpc] = find(isinf(f));
f(:,unique(tmpc)) = []; %%
%f(unique(tmpr),:) = []; 
%classlabels(unique(tmpr),:) = []; 
%antibodyids(unique(tmpr),:) = []; 

if length(unique(classlabels))~=length(classes)
   error('Some class has been deleted!');
end

F = f;
clear f
M = size(F,1); K = length(classes);
Y = sparse(1:M, classlabels, 1, M, K);
if sum(sum(Y,2))~=M
   error('Check Y!.');
end


boolvar = 0;
if exist('Nfolds','var')
    boolvar = 1;
end

abids2 = antibodyids;

Ninit = 5;
[trainidx,testidx, protlabels,N] = splitbyproteins( classlabels, abids2, Ninit);

for i = 1:Ninit
    disp(['split the fold ',num2str(i)]);
    trIdx = ismember(protlabels,trainidx{i});
    teIdx = ismember(protlabels,testidx{i});

    fold = i;
    save([datafile(1:end-4),'-',num2str(i),'.mat'],'-v7.3','F','Y','classes','fold','trIdx','teIdx','antibodyids');
end
return;
end

%%

f = double(f); f(isnan(f)) = 0;

tmpmax = max(f,[],1);
tmpmin = min(f,[],1);
tmpidx = find((tmpmax-tmpmin)<=1e-2);
f(:,tmpidx) = [];

[tmpr,tmpc] = find(isinf(f));
f(:,unique(tmpc)) = []; %%
%f(unique(tmpr),:) = []; 
%classlabels(unique(tmpr),:) = []; 
%antibodyids(unique(tmpr),:) = []; 

if length(unique(classlabels))~=length(classes)
   error('Some class has been deleted!');
end

F = f;
clear f
M = size(F,1); K = length(classes);
Y = sparse(1:M, classlabels, 1, M, K);
if sum(sum(Y,2))~=M
   error('Check Y!.');
end

nfolds = 5;
cvo = cvpartition(M, 'kfold', nfolds);
for i = 1:cvo.NumTestSets
    disp(['split the fold ',num2str(i)]);
    trIdx = cvo.training(i);
    teIdx = cvo.test(i);

    fold = i;
    save([datafile(1:end-4),'-',num2str(i),'.mat'],'-v7.3','F','Y','classes','fold','trIdx','teIdx','antibodyids');
end

