function [obj, grad] = pc_PCO_F(x, T, lam)

global pc_F pc_Y

M = size(pc_F,1);
D = size(pc_F,2);
K = size(pc_Y,2);

W = reshape(x,[D,T,K]);

Phi = reshape(exp(pc_F*reshape(W, [D, T*K])), [M, T, K]);
Z = squeeze(sum(sum(Phi,3),2));
PCO_F = bsxfun(@times, Phi, 1./Z);
PC_F = squeeze(sum(PCO_F,2));

obj = -sum(log(1e-100+PC_F(find(pc_Y)))) +...
    0.5*lam*(sum(W(:).^2));

if nargout > 1

PO_CF = bsxfun(@times, bsxfun(@times, PCO_F, reshape(full(pc_Y), [M,1,K])), 1./reshape(PC_F + 1e-100, [M,1,K])); 

grad = pc_F'*reshape(PO_CF - PCO_F, [M,T*K]);
grad = -grad(:)+lam*W(:);

end

clear W Phi Z PCO_F PC_F PO_CF
