function [ r ] = randm(p, n)
% [ r ] = randm( p, n)
% sample from a multinomial. return a column vector
% p: probability vector, should sum to 1. if a scalar then p means the number of bins
% n: number of samples to draw

if nargin < 2
    n = 1;
end

if isscalar(p) %this is for uniform, p is the # of classes
    r = floor(rand(n,1)*p) + 1;
else
    cum_p = cumsum(p(:));
    assert(abs(cum_p(end) - 1) < 1e-10, 'wrong distribution');
    
    d = bsxfun(@minus, cum_p, rand(1, n));
    [dummy, r] = min((d <= 0)*2 + d, [], 1);
end
