function [C]=scale(A, s, for_cols)
% scale(A, s, for_cols)
% scale columns/rows by s

if nargin < 3
    for_cols=true;
    if nargin < 2
        s=[];
    end
end

if isempty(s)
    s=1./full(sum(A, choose(for_cols, 1, 2)));
else
    s=full(s);
end
s(isinf(s))=1;

if issparse(A)
    if for_cols
        C=A*spdiags(s, 0, size(A, 2), size(A, 2));
    else
        C=spdiags(s, 0, size(A, 1), size(A, 1))*A;
    end
else
    if for_cols
        C=bsxfun(@times, A, s(:)');
    else
        C=bsxfun(@times, A, s(:));
    end    
end
