%% script for running HCRF; called by batch_cell_all.m


%rand('twister', sum(100*clock));  %%
rand('seed',2^iii+3^jjj+5^T+7^nf); randn('seed',2^iii+3^jjj+5^T+7^nf);

if ~exist(sprintf([outfolder,'pc_data_crf_%d_%d.mat'], nNode, nnk),'file')  %%
load(dataname)

data = cell(1, length(W));
for ind = 1:length(W)
    w = W(ind);
    
    % add the position feature
    %w.Center(find(isnan(w.Center))) = 0;
    w.Centers = w.Center; w.Center = [];
    %w.CellCenter = mean(w.Centers, 1);  %%
    w.CellCenter = w.center_prot;  %% 
    w.CellRadius = mean(L2Dist(w.CellCenter', w.Centers'))*2;
    
    % subsample
    filter = RI(nNode, size(w.G,1));
    w.G = w.G(filter,:);
    w.Centers = w.Centers(filter,:);
    
    % make the graph
    %edges = MakeKNNGraph(w.Centers, nnk);
    edges = MakeKNNGraph(w.Centers, min(size(w.Centers,1)-1,nnk));
    w.E = int32([edges(:, [1,2]); edges(:,[2,1])]);
    w.F = repmat(edges(:,3),2,1)./w.CellRadius;

    tmp = w.F;    w.F = w.G;    w.G = tmp;
    data{ind} = w;
    %TraceIter(ind, 1, length(W));
end

clear w dist_to_center filter edges nfolds cvo KN Sampling ind W
save(sprintf([outfolder,'pc_data_crf_%d_%d.mat'], nNode, nnk),'data');  %%
end

%% initialize

% nNode = 50;
% nnk = 5;
% T = 2;

load(sprintf([outfolder,'pc_data_crf_%d_%d.mat'], nNode, nnk),'data');

anti_id = AssembleVector(data, 'anti');
anti_id = EncodeInt(int32(anti_id));
labels_c = AssembleVector(data, 'L');
labels_a = Vote(labels_c, anti_id);
K = length(unique(labels_c));

u_aid = unique(anti_id);
if exist('trainidx','var') && exist('testidx','var')
   trI = find(ismember(anti_id,trainidx{nf}));
   teI = find(ismember(anti_id,testidx{nf}));
   subsample;  %%
else
if separate
    trI = EncodeInt(anti_id, u_aid(RI(round(0.5*length(u_aid)), length(u_aid)))); %half split
    trI = L2I(trI);
    teI = L2I(~I2L(trI, length(data)));
else
    trI = RI(round(0.5*length(data)), length(data));
    teI = L2I(~I2L(trI, length(data)));
end
end


cluster = 1;  %%
isenums = 1;  %%
%[data, enums] = HCRFSetup(data, T, K, nnk, cluster, 1, 5);  %%
%[data, enums] = HCRFSetup(data, T, K, nnk, cluster, 1, NaN);  %%
[data, enums] = HCRFSetup(data, T, K, nnk, cluster, 1, 5, isenums);  %%
data_ne = data;
for ind = 1:length(data)
    data_ne{ind}.G = [];
    data_ne{ind}.E = [];
end

dA = size(data{1}.F, 2);
dI = size(data{1}.G, 2);

options = struct('nX',K,'nH',T,'ridge',ridge,'enums',{enums});

%% hcrf lbfgs ne

options.Display = 'on';
options.Method = 'lbfgs';
options.maxIter = 100;
nparam = HCRFGetParamIndex(K, T, dA, 0);
WS = cell(1,5); objs = zeros(1, length(WS));
for ind = 1:length(WS)
    fprintf(fid,'ind %d\n',ind); %%
    options.init = randn(nparam,1)*1e-2;
    [WS{ind} objs(ind)] = HCRFTrain(data_ne(trI), options);
end
model_ne = WS{argmin(objs)};
%model_ne = WS{argmax(objs)};

t_hcrfne_tr = HCRFTest(data_ne(trI), model_ne, options);
[t_hcrfne_c p_hcrfne_c] = HCRFTest(data_ne(teI), model_ne, options);
t_hcrfne_a = Vote(t_hcrfne_c, anti_id(teI));
t_hcrfne_a_pv = VoteProb(p_hcrfne_c, anti_id(teI));
acc_hcrfne_tr = mean(t_hcrfne_tr == labels_c(trI));
acc_hcrfne_c = mean(t_hcrfne_c == labels_c(teI));
acc_hcrfne_a = mean(t_hcrfne_a(find(~isnan(t_hcrfne_a))) == labels_a(find(~isnan(t_hcrfne_a))));
acc_hcrfne_a_pv = mean(t_hcrfne_a_pv(find(~isnan(t_hcrfne_a_pv))) == labels_a(find(~isnan(t_hcrfne_a_pv))));

fprintf('** No Edge: %0.2f%%, %0.2f%%, %0.2f%%, %0.2f%%\n',acc_hcrfne_tr*100, acc_hcrfne_c*100, acc_hcrfne_a*100, acc_hcrfne_a_pv*100);
fprintf(fid,'** No Edge: %0.2f%%, %0.2f%%, %0.2f%%, %0.2f%%\n',acc_hcrfne_tr*100, acc_hcrfne_c*100, acc_hcrfne_a*100, acc_hcrfne_a_pv*100);

clear data_ne
%%

acc_hcrfc_tr=0;acc_hcrfc_c=0;acc_hcrfc_a=0;acc_hcrfc_a_pv=0;
docluster = 1;  %%
if docluster == 1
options.maxIter = 50;
[nparam wi] = HCRFGetParamIndex(K, T, dA, dI);
options.init = randn(nparam,1)*1e-2; options.init(wi) = model_ne.theta;
modelc = HCRFTrain(data(trI), options);

t_hcrfc_tr = HCRFTest(data(trI), modelc, options);
[t_hcrfc_c p_hcrfc_c] = HCRFTest(data(teI), modelc, options);
t_hcrfc_a = Vote(t_hcrfc_c, anti_id(teI));
t_hcrfc_a_pv = VoteProb(p_hcrfc_c, anti_id(teI));
acc_hcrfc_tr = mean(t_hcrfc_tr == labels_c(trI));
acc_hcrfc_c = mean(t_hcrfc_c == labels_c(teI));
acc_hcrfc_a = mean(t_hcrfc_a(find(~isnan(t_hcrfc_a))) == labels_a(find(~isnan(t_hcrfc_a))));
acc_hcrfc_a_pv = mean(t_hcrfc_a_pv(find(~isnan(t_hcrfne_a_pv))) == labels_a(find(~isnan(t_hcrfne_a_pv))));

fprintf('** Cluster: %0.2f%%, %0.2f%%, %0.2f%%, %0.2f%%\n',acc_hcrfc_tr*100, acc_hcrfc_c*100, acc_hcrfc_a*100, acc_hcrfc_a_pv*100);
fprintf(fid,'** Cluster: %0.2f%%, %0.2f%%, %0.2f%%, %0.2f%%\n',acc_hcrfc_tr*100, acc_hcrfc_c*100, acc_hcrfc_a*100, acc_hcrfc_a_pv*100);
end

%% 

accs = [acc_hcrfne_tr,acc_hcrfne_c,acc_hcrfne_a, acc_hcrfne_a_pv,...
    acc_hcrfc_tr,acc_hcrfc_c,acc_hcrfc_a, acc_hcrfc_a_pv];


clear data data_ne
