M = 10;
N = 200;
nnk = 5;
loc = true;
noise = 0.2;

Ts = 1:2;
ntry = 10;

accss = zeros(10, length(Ts), ntry);
for iii = 1:ntry
    T = 2;
    K = 5;
    tag = sprintf('%d_%d_%d',T,K,noise*100);
    
    data = simulation(2, 4, M, N, noise, loc);

    for ind = 1:N
        edges = MakeKNNGraph(data{ind}.Centers, nnk);
        data{ind}.E = [edges(:, [1,2]); edges(:, [2,1])];
        data{ind}.G = repmat(edges(:,3),2,1);
    end

    % preprocess features
    F = AssembleMatrix(data, 'F', true);F = zscore(F);
    F = [ones(size(F,1),1) F];
    G = AssembleMatrix(data, 'G', true);G = zscore(G);
    G = [ones(size(G,1),1) G];
    Fs = mat2cell(F, cellfun(@(x) size(x.F,1), data));
    Gs = mat2cell(G, cellfun(@(x) size(x.G,1), data));
    for ind = 1:length(data)
        data{ind}.F = Fs{ind};        data{ind}.G = Gs{ind};
    end

    data_ne = data;
    for ind = 1:length(data)
        data_ne{ind}.G = [];        data_ne{ind}.P = [];
    end

    labels = AssembleVector(data, 'L');
    [nNode dA] = size(data{1}.F);
    dI = size(data{1}.G, 2);

    trI = RI(round(N*0.5), N);
    teI = L2I(~I2L(trI, N));
    
    for jjj = 1:length(Ts)
        T = Ts(jjj);
        [iii, jjj]
        
        demo_hcrf;
        accss(:,jjj,iii) = accs(:);
        
        save(['accss_sim_' tag]);
    end
end

%%

% load accss

a = mean(accss, 3);

figure;
filter = 2:2:10;
plot(a(filter, :)');
names = {'hlr r', 'hlr c', 'hcrf ne tr', 'hcrf ne c', 'hcrfq tr', 'hcrfq c',...
    'hcrf tr', 'hcrf c', 'hcrfs tr', 'hcrfs c'};
legend(names{filter});
