function [data] = simulation(T, K, M, N, noise, loc)

if nargin == 0
    T = 2;
    K = 3;
    M = 10;
    N = 200;
    
    noise = 0.01;
    loc = true;
end

src = cell(K, 1);
for knd = 1:K
   src{knd} = GMM(ones(1, T), rand(2, T), noise);
end

data = cell(1, N);
for n = 1:N
    L = randm(K);
    [F O] = src{L}.GenData(M);
    
    if loc
        centers = zeros(M, 2);
        for t = 1:T
            idx = find(O == t);
            centers(idx,:) = rand(length(idx), 2) + t*5;
        end
    else
        centers = rand(M, 2);
    end
    
    data{n} = struct('F',F, 'L',L, 'O',O, 'Centers', centers);
end

