%% script for wrapping results of PCO for HCRF,
%% which are used in Figure 9 (b) in the paper.

close all
clear all


%% wrap PCO_F

%% for the best case
nNode = 50;
nnk = 5;

Ts_all = 3;  %%%%%%%%%%%%%%%%
foldfile_ind = 4;  %%%%%%%%%%
for iTs = Ts_all
for ifoldfile = foldfile_ind

T = iTs;  %%

outfolder = ['./tmp/pc-9-',num2str(ifoldfile),'/'];

dataname = './data/pc/structFeat9-KN3.mat';  %%

Nfolds_all = 1:5;  %%

bHXs = 0;
for iNfolds = Nfolds_all


SDA = 0;
ntry = 1; %%
ridge = 100;
separate = true;

load(['./data/pc/regionfeatures_5folds',num2str(ifoldfile),'.mat'], 'Nfolds', 'trainidx', 'testidx');

Nfolds = iNfolds;  %%

for iii = 1:ntry
        
        for nf = Nfolds
            disp(['evaluating fold: ' num2str(nf)]); 

            load([outfolder,'accss',num2str(iii),'-',num2str(T),'-',num2str(nf),'.mat']); 
        
            load(sprintf([outfolder,'pc_data_crf_%d_%d.mat'], nNode, nnk),'data');
            rand('seed',2^iii+3^jjj+5^T+7^nf); randn('seed',2^iii+3^jjj+5^T+7^nf);
	     cluster = 1;  %%
            isenums = 1;  %%
            [data, enums] = HCRFSetup(data, T, K, nnk, cluster, 1, 5, isenums);  %%
            data_ne = data;
            for ind = 1:length(data)
                data_ne{ind}.G = [];
                data_ne{ind}.E = [];
            end

	     options = struct('nX',K,'nH',T,'ridge',ridge,'enums',{enums});
	     options.Display = 'on';
	     options.Method = 'lbfgs';
	     options.maxIter = 100;

	     [dummy, dummy, bHX] = HCRFTest(data_ne(teI), model_ne, options);  %%

	     %options.maxIter = 50;
            %[dummy, dummy, bHX] = HCRFTest(data(teI), modelc, options);  %%

	     bHXs = bHXs + bHX;
        end
end


end

clear data_ne data
save bHXs.mat

end
end


PCO_F_all = bHXs;
PCO_F_all = PCO_F_all./repmat(sum(PCO_F_all,2),[1,size(PCO_F_all,2)])

image(PCO_F_all*255)
colormap(jet(ceil(max(max(PCO_F_all*255)))))
colorbar('YTickLabel',[])
set(gca,'XTick',[1:size(PCO_F_all,2)])

