%% script for wrapping results for HCRF

clear all
close all

outfolders = [{'./tmp/pc-9/'},{'./tmp/pc-9-2/'},{'./tmp/pc-9-3/'},{'./tmp/pc-9-4/'},{'./tmp/pc-9-5/'}];

for iout = 1:length(outfolders)
outfolder = outfolders{iout};

allT = [1,2,3,4,5,6];
allnf = [1,2,3,4,5];

all_acctrne_cell = zeros(length(allT),length(allnf));
all_acctene_cell = zeros(length(allT),length(allnf));
all_acctene_anti = zeros(length(allT),length(allnf));
all_acctene_antip = zeros(length(allT),length(allnf));
all_acctrc_cell = zeros(length(allT),length(allnf));
all_acctec_cell = zeros(length(allT),length(allnf));
all_acctec_anti = zeros(length(allT),length(allnf));
all_acctec_antip = zeros(length(allT),length(allnf));
all_numtr_cell = zeros(length(allT),length(allnf));
all_numtr_anti = zeros(length(allT),length(allnf));
all_numte_cell = zeros(length(allT),length(allnf));
all_numte_anti = zeros(length(allT),length(allnf));
all_liktene_cell = zeros(length(allT),length(allnf));
all_liktec_cell = zeros(length(allT),length(allnf));

result_acctrne_cell = zeros(length(allT));
result_acctene_cell = zeros(length(allT));
result_acctene_anti = zeros(length(allT));
result_acctene_antip = zeros(length(allT));
result_acctrc_cell = zeros(length(allT));
result_acctec_cell = zeros(length(allT));
result_acctec_anti = zeros(length(allT));
result_acctec_antip = zeros(length(allT));
result_liktene_cell = zeros(length(allT));
result_liktec_cell = zeros(length(allT));
for itt = allT
    for iff = allnf
        file = [outfolder,'accss1-',num2str(itt),'-',num2str(iff),'.mat'];
	 if exist(file, 'file')
        load(file,'acc_hcrfne_tr','acc_hcrfne_c','acc_hcrfne_a','acc_hcrfne_a_pv','acc_hcrfc_tr','acc_hcrfc_c','acc_hcrfc_a','acc_hcrfc_a_pv',...
            'teI','anti_id','trI','p_hcrfne_c','p_hcrfc_c');
	 else
	 load([outfolder,'tmp',num2str(itt),num2str(iff),'.mat'],'acc_hcrfne_tr','acc_hcrfne_c','acc_hcrfne_a','acc_hcrfne_a_pv',...
            'teI','anti_id','trI','p_hcrfne_c');  %%
	 acc_hcrfc_tr = acc_hcrfne_tr; acc_hcrfc_c = acc_hcrfne_c; acc_hcrfc_a = acc_hcrfne_a; acc_hcrfc_a_pv = acc_hcrfne_a_pv; p_hcrfc_c = p_hcrfne_c;  %%
	 end

        all_acctrne_cell(itt,iff) = acc_hcrfne_tr;
        all_acctene_cell(itt,iff) = acc_hcrfne_c;
        all_acctene_anti(itt,iff) = acc_hcrfne_a;
        all_acctene_antip(itt,iff) = acc_hcrfne_a_pv;

        all_acctrc_cell(itt,iff) = acc_hcrfc_tr;
        all_acctec_cell(itt,iff) = acc_hcrfc_c;
        all_acctec_anti(itt,iff) = acc_hcrfc_a;
        all_acctec_antip(itt,iff) = acc_hcrfc_a_pv;

        all_numte_cell(itt,iff) = length(teI);
        all_numte_anti(itt,iff) = length(unique(anti_id(teI)));
        all_numtr_cell(itt,iff) = length(trI);
        all_numtr_anti(itt,iff) = length(unique(anti_id(trI)));

        all_liktene_cell(itt,iff) = sum(log(max(p_hcrfne_c,[],2)));
        all_liktec_cell(itt,iff) = sum(log(max(p_hcrfc_c,[],2)));
    end
end
clear acc_hcrfne_tr acc_hcrfne_c acc_hcrfne_a acc_hcrfne_a_pv acc_hcrfc_tr acc_hcrfc_c acc_hcrfc_a acc_hcrfc_a_pv teI anti_id trI p_hcrfne_c p_hcrfc_c

result_acctrne_cell = sum(all_acctrne_cell.*all_numtr_cell,2)./sum(all_numtr_cell,2);
result_acctene_cell = sum(all_acctene_cell.*all_numte_cell,2)./sum(all_numte_cell,2);
result_acctene_anti = sum(all_acctene_anti.*all_numte_anti,2)./sum(all_numte_anti,2);
result_acctene_antip = sum(all_acctene_antip.*all_numte_anti,2)./sum(all_numte_anti,2);
result_acctrc_cell = sum(all_acctrc_cell.*all_numtr_cell,2)./sum(all_numtr_cell,2);
result_acctec_cell = sum(all_acctec_cell.*all_numte_cell,2)./sum(all_numte_cell,2);
result_acctec_anti = sum(all_acctec_anti.*all_numte_anti,2)./sum(all_numte_anti,2);
result_acctec_antip = sum(all_acctec_antip.*all_numte_anti,2)./sum(all_numte_anti,2);
result_liktene_cell = sum(all_liktene_cell,2);
result_liktec_cell = sum(all_liktec_cell,2);

%if we allow different folds having different T
result_acctrne_cell_nf = 0;
result_acctene_cell_nf = 0;
result_acctene_anti_nf = 0;
result_acctene_antip_nf = 0;
result_acctrc_cell_nf = 0;
result_acctec_cell_nf = 0;
result_acctec_anti_nf = 0;
result_acctec_antip_nf = 0;

[dump,ind] = max(all_liktene_cell,[],1);
indm = full(sparse(ind,allnf,ones(length(allnf),1)));
indm = [indm; zeros(length(allT)-size(indm,1),length(allnf))];
result_acctrne_cell_nf = sum(sum(all_acctrne_cell.*all_numtr_cell.*indm,1),2)./sum(sum(all_numtr_cell.*indm,1),2);
result_acctene_cell_nf = sum(sum(all_acctene_cell.*all_numte_cell.*indm,1),2)./sum(sum(all_numte_cell.*indm,1),2);
result_acctene_anti_nf = sum(sum(all_acctene_anti.*all_numte_anti.*indm,1),2)./sum(sum(all_numte_anti.*indm,1),2);
result_acctene_antip_nf = sum(sum(all_acctene_antip.*all_numte_anti.*indm,1),2)./sum(sum(all_numte_anti.*indm,1),2);
result_acctrc_cell_nf = sum(sum(all_acctrc_cell.*all_numtr_cell.*indm,1),2)./sum(sum(all_numtr_cell.*indm,1),2);
result_acctec_cell_nf = sum(sum(all_acctec_cell.*all_numte_cell.*indm,1),2)./sum(sum(all_numte_cell.*indm,1),2);
result_acctec_anti_nf = sum(sum(all_acctec_anti.*all_numte_anti.*indm,1),2)./sum(sum(all_numte_anti.*indm,1),2);
result_acctec_antip_nf = sum(sum(all_acctec_antip.*all_numte_anti.*indm,1),2)./sum(sum(all_numte_anti.*indm,1),2);


save([outfolder 'wrap_results.mat']);

end
