%% script for using HLR

clear all
clear global

dataname = './structFeat9-KN3-4HLR.mat';

for ifolds = 1:5
for iTs = 1:10
for iNfolds = 1:5

outfolder = ['./tmp/pc-2sets-',num2str(ifolds),'/'];

if ~exist('outfolder','dir')
   mkdir(outfolder);
end

Ts = iTs;  %%
ntry = 1; %%

load(['../HCRF/data/pc/regionfeatures_5folds',num2str(ifolds),'.mat'], 'Nfolds', 'trainidx', 'testidx');

Nfolds = iNfolds;  %%

tmpfile = [outfolder,'batch_cell',num2str(Ts),num2str(Nfolds),'.txt'];
if exist(tmpfile, 'file')
   continue;
end
fid = fopen(tmpfile,'w');
tmpfile

for iii = 1:ntry
    for jjj = 1:length(Ts)
        disp([iii jjj]);
        
        T = Ts(jjj);
        for nf = Nfolds
            disp(['evaluating fold: ' num2str(nf)]); 

            fprintf(fid,'iii %d, jjj %d, T %d, nfold %d.\n',iii,jjj,T,nf);
            run_HLR;
        
            save([outfolder,'accss',num2str(iii),'-',num2str(T),'-',num2str(nf),'.mat']); 
        end
    end
end


fclose(fid);

end
end
end
