M = 10000; % # regions
D = 10; % dim of observation
T = 3; % # org
K = 3; % # classes

[F, Y, W, V, P] = simulate(M, D, T, K);
[dummy labels] = max(Y, [], 2);


T_all = 10;
acc = zeros(T_all,1);
for T = 1:T_all
%%

options.Method = 'lbfgs';
options.MaxIter = 100;
options.Display='on';

% options.DerivativeCheck = 'on';
% param0 = randn(D*T*(K + 1), 1)*1e-1;
% [param,val,exitflag,output] = minFunc(@(x) pc_obj(x, F, Y, T, 1), param0, options);

options.DerivativeCheck = 'off';
options.Display= 'on';
cvo = cvpartition(M, 'k', 3);
pred = zeros(M,1);
for i = 1:cvo.NumTestSets
    trI = cvo.training(i);
    teI = cvo.test(i);
    
    ntry = 1;
    objs = zeros(1,ntry);
    results = cell(1,ntry);
    trF = F(trI,:);
    trY = Y(trI,:);
    func = @(x) pc_obj(x, trF, trY, T, 1e-3);
    for tnd = 1:ntry
        param0 = randn(D*T*K,1)*0.5;
        [results{tnd}, objs(tnd)] = minFunc(func, param0, options);
    end
    [dummy ii] = min(objs);
    param = results{ii};

    eW = reshape(param,[D,T,K]);

    Phi = reshape(exp(F*reshape(eW, [D, T*K])), [M, T, K]);
    Z = squeeze(sum(sum(Phi,3),2));
    PCO_F = bsxfun(@times, Phi, 1./Z);
    eP = squeeze(sum(PCO_F,2));

    [dummy t] = max(eP, [], 2);
    pred(teI) = t(teI);
    
    fprintf('Fold %d: Tr acc = %g, Te acc = %g\n', i, ...
        mean(labels(trI) == t(trI)), mean(labels(teI) == t(teI)));
end
cvAcc = mean(labels == pred)

acc(T) = cvAcc;
end

h = figure;
plot([1:length(acc)],acc,'-b','LineWidth',6);
xlabel('T (number of latent organelles)','Fontsize',14,'FontWeight','bold');
set(gca,'XTick',[0:length(acc)]);
ylabel('mean accuracy','Fontsize',14,'FontWeight','bold');
title('Simulation','Fontsize',14,'FontWeight','bold');
box on;
set(gca,'FontSize',14,'FontWeight','bold');
print(h, '-dpsc2', '-r600', 'Schneider.223.fig.6.eps');
print(h, '-dtiff', '-r600', 'Schneider.223.fig.6.tif');
