function [obj, grad] = pc_obj(x, F, Y, T, lam)

M = size(F,1);
D = size(F,2);
K = size(Y,2);

W = reshape(x,[D,T,K]);

Phi = reshape(exp(F*reshape(W, [D, T*K])), [M, T, K]);
Z = squeeze(sum(sum(Phi,3),2));
PCO_F = bsxfun(@times, Phi, 1./Z);
PC_F = squeeze(sum(PCO_F,2));

obj = -sum(log(1e-100+PC_F(find(Y)))) + 0.5*lam*(sum(W(:).^2));

if nargout > 1
    PO_CF = bsxfun(@times, bsxfun(@times, PCO_F, reshape(full(Y),[M,1,K])), 1./reshape(PC_F + 1e-100, [M,1,K]));

    grad = F'*reshape(PO_CF - PCO_F, [M,T*K]);
    grad = -grad(:)+lam*W(:);
end
