%% running HLR called by batch_cell_all.m

%Modified from ./run_iso.m (and ../protein_jyl/run_crf2.m).

datafile = dataname;
load(datafile)

protlabels = EncodeInt(int32(antibodyids));

[dumy labels] = max(Y, [], 2);

[M, D] = size(F);
[M, K] = size(Y);
M

fprintf(fid,'M=%d, T=%d, D=%d, K=%d\n',M,T,D,K);

lambda = [100];

options.Method = 'lbfgs';
options.MaxIter = 100; %
options.Display= 'on';

pred = zeros(M,1);

    fprintf(fid,'nf=%d\n',nf);
    trI = find(ismember(protlabels,trainidx{nf}));
    teI = find(ismember(protlabels,testidx{nf}));
    
    ntry = 3; %
    objs = zeros(length(lambda),ntry);
    results = cell(length(lambda),ntry);
    trF = F(trI,:);
    trY = Y(trI,:);
    for ll = 1:length(lambda)
        func = @(x) pc_obj(x, trF, trY, T, lambda(ll));    
        parfor tnd = 1:ntry
            param0 = randn(D*T*K, 1)*1e-2;
            [results{ll,tnd}, objs(ll,tnd)] = minFunc(func, param0, options);
        end
    end
    clear trF trY
    [dummy ii] = min(objs(:))
    results = results(:);
    param = results{ii};
    objs_all = dummy;
    
    eW = reshape(param,[D,T,K]);

    Phi = reshape(exp(F*reshape(eW, [D, T*K])), [M, T, K]);
    Z = squeeze(sum(sum(Phi,3),2));
    PCO_F = bsxfun(@times, Phi, 1./Z);
    eP = squeeze(sum(PCO_F,2));

    [dummy t] = max(eP, [], 2);
    pred(teI) = t(teI);
    
    fprintf(fid,'Fold %d: Tr acc = %g, Te acc = %g\n', nf, ...
        mean(labels(trI) == t(trI)), mean(labels(teI) == t(teI)));
    clear Phi Z PCO_F eW trF 


clear F Y

