clear all
clear global

addpath(genpath('/home/jieyuel/lib_backup/PGM_Project/minFunc'))
addpath('/home/jieyuel/lib_backup/PGM_Project')
addpath('/home/jieyuel/lib_backup/lib_Justin/lib/classification')


%datafile = './pc_data.mat';
%datafile = '/home/jieyuel/lib_backup/PGM_Project/data/fandg_single_A431R2-12.mat';
%datafile = '/home/jieyuel/lib_backup/data/IF_atlas_5/regionfeatures_single_A431R2-fg.mat'

%datafile = '/home/jieyuel/lib_backup/data/IF_atlas_5/regionfeatures_single_A431R2-2-fg.mat'
%datafile = '/home/jieyuel/lib_backup/data/IF_atlas_5/regionfeatures_all_A431R2-2-fg.mat'
%datafile = '/home/jieyuel/lib_backup/data/IF_atlas_5/regionfeatures_all_A431R2-fg.mat'
%datafile = '/home/jieyuel/lib_backup/data/IF_atlas_5/fg5_single_A431R2.mat';
datafile = '/home/jieyuel/lib_backup/data/IF_atlas_5/fg5_single_A431R2_pca.mat';

load(datafile,'F','Y','antibodyids','classlabels','ispca');
antibodyids = double(antibodyids);
classlabels = double(classlabels);

%T = 2
T_all = 4

% Y = [Y(:,[2,7,8]), sum(Y(:,9:11),2), Y(:,13)];
filter = sum(Y,2) > 0;
if length(find(filter))<size(Y,1) 
   if (exist('ispca','var')) && (ispca==1)
      load([datafile(1:end-8),'.mat'],'F','Y','antibodyids','classlabels');
      ispca = 0;
   end
%F = single(F); %%avoid out of memory
Y = Y(filter,:);
F = F(filter,:);
antibodyids = antibodyids(filter,:);
if ~exist('classlabels','var')
   [tmp,classlabels] = find(Y);
   [tmp,IX] = sort(tmp);
   classlabels = classlabels(IX);
   clear tmp;
end
end

if (~exist('ispca','var')) || (ispca~=1)
%F = zscore(F); %%%
%F = double(F); %
%pca = PCA(F, 0.95);
pca = PCA(F, 0.80);
F = pca.Project(F);
F = double(F); %%
F = [F, ones(size(F, 1),1)];
end


[dumy labels] = max(Y, [], 2);

[M, D] = size(F);
[M, K] = size(Y);
M


for iT = 1:length(T_all)
%%
T = T_all(iT)

tmpfile = [datafile,'-',num2str(T),'.txt'];
fid = fopen(tmpfile,'w');
fprintf(fid,'M=%d, T=%d, D=%d\n',M,T,D);

%lambda = [0.001,0.01,0.1,1,10,100];
%lambda = [1000,10000]
lambda = [0.01,1,100];

options.Method = 'lbfgs';
%options.MaxIter = 200; %
options.MaxIter = 100; %
options.Display= 'on';

%trial = 10; %
trial = 3; %
nfolds = 5; %

pred_all = zeros(M,trial);
eP_all = cell(trial,1);
objs_all = zeros(trial,nfolds);

for tt = 1:trial
fprintf(fid,'tt=%d\n',tt);
%cvo = cvpartition(M, 'k', nfolds); %
[trainidx,testidx, protlabels,N] = splitbyproteins( classlabels, antibodyids, nfolds); %
pred = zeros(M,1);
%for i = 1:cvo.NumTestSets
for i = 1:nfolds
    fprintf(fid,'i=%d\n',i);
%    trI = cvo.training(i);
%    teI = cvo.test(i);
    trI = find(ismember(protlabels,trainidx{i}));
    teI = find(ismember(protlabels,testidx{i}));
    
    ntry = 3; %
    objs = zeros(length(lambda),ntry);
    results = cell(length(lambda),ntry);
    trF = F(trI,:);
    trY = Y(trI,:);
    for ll = 1:length(lambda)
    func = @(x) pc_obj(x, trF, trY, T, lambda(ll));    
    parfor tnd = 1:ntry
        param0 = randn(D*T*K, 1)*0.5;
        [results{ll,tnd}, objs(ll,tnd)] = minFunc(func, param0, options);
    end
    end
    [dummy ii] = min(objs(:));
    results = results(:);
    param = results{ii};
    objs_all(tt,i) = dummy;
    
    eW = reshape(param,[D,T,K]);

    Phi = reshape(exp(F*reshape(eW, [D, T*K])), [M, T, K]);
    Z = squeeze(sum(sum(Phi,3),2));
    PCO_F = bsxfun(@times, Phi, 1./Z);
    eP = squeeze(sum(PCO_F,2));

    [dummy t] = max(eP, [], 2);
    pred(teI) = t(teI);
    
    fprintf(fid,'Fold %d: Tr acc = %g, Te acc = %g\n', i, ...
        mean(labels(trI) == t(trI)), mean(labels(teI) == t(teI)));
    clear Phi Z PCO_F eW 
end
cvAcc(tt) = mean(labels == pred)
pred_all(:,tt) = pred;
eP_all{tt} = eP;
end

save([datafile(1:end-4),'_run_iso-',num2str(T),'.mat'],'cvAcc','pred_all','eP_all','T','objs_all');

fclose(fid);
clear T
end
