function [F, Y, W, V, P] = simulate(M, D, T, K)

if nargin == 0
    M = 10000; % # regions
    D = 100; % dim of observation
    T = 2; % # org
    K = 10; % # classes
end

F = randn(M, D);
W = randn(D, T);
V = randn(D, T, K);

A = mlogit(F*W); 
[dummy, o] = max(A, [], 2);
A = full(sparse(1:M, o, 1, M, T));
B = reshape(F*reshape(V, [D, T*K]), [M, T, K]);
B = reshape(mlogit(reshape(B, [M*T, K])), [M, T, K]);
C = bsxfun(@times, B, A);
P = squeeze(sum(C, 2));

labels = zeros(M, 1);
for ind = 1:M
    labels(ind) = randm(P(ind, :), 1);
end
[dummy labels] = max(P, [], 2);

Y = sparse(1:M, labels, 1, M, K);
