%% wrapping all results for HLR

close all
clear all


load structFeat9-KN3-4HLR.mat antibodyids classlabels

datafile = '../HCRF/data/pc/structFeat9-KN3.mat';
load(datafile, 'W');
cellids = [];
for i=1:length(W)
    cellids = [cellids; i*ones(size(W(i).G,1),1)];
end
clear W


files = dir(['wrap_results*.mat']);
Acc_all = [];
Acc_cell_all = [];
Acc_anti_all = [];
for i=1:length(files)
    i
    clear pred_all
    load(files(i).name,'cvAcc','eP_all');
    pred_all = [];
    for tt=1:length(eP_all)
        [dummy t] = max(eP_all{tt}, [], 2);
        pred_all = [pred_all,t];
    end

    Acc_all(i,:) = cvAcc;

    for j=1:size(pred_all,2)
        j
        [tmp_protlabels,tmp_protpredlabels,proteins] = ...
            voteAcrossProtein( eP_all{j}, classlabels, cellids );
        [tmp_cc3 tmp_uu3 tmp_dd3 tmp_ww3] = conmatrix( tmp_protlabels, tmp_protpredlabels);
        Acc_cell_all(i,j) = tmp_uu3;

        [tmp_protlabels,tmp_protpredlabels,proteins] = ...
            voteAcrossProtein( eP_all{j}, classlabels, antibodyids );
        [tmp_cc3 tmp_uu3 tmp_dd3 tmp_ww3] = conmatrix( tmp_protlabels, tmp_protpredlabels);
        Acc_anti_all(i,j) = tmp_uu3;
	 Acc_anti_all
    end
end

std(Acc_all,0,2)

std(Acc_cell_all,0,2)

std(Acc_anti_all,0,2)


save('HLR_wrap_results.mat','Acc_all','Acc_cell_all','Acc_anti_all');

