%% script for wrapping results of PCO for HLR,
%% which are used in Figure 9 (a) in the paper.

close all
clear all
clear global

dataname = './structFeat9-KN3-4HLR.mat';

PCO_F_all = 0;
for ifolds = 5
for iTs = 2
for iNfolds = 1:5

outfolder = ['./tmp/pc-2sets-',num2str(ifolds),'/'];

Ts = iTs;  %%
ntry = 1; %%

load(['../HCRF/data/pc/regionfeatures_5folds',num2str(ifolds),'.mat'], 'Nfolds', 'trainidx', 'testidx');
Nfolds = iNfolds;  %%

for iii = 1:ntry
    for jjj = 1:length(Ts)
        disp([iii jjj]);
        
        T = Ts(jjj);
        for nf = Nfolds
            disp(['evaluating fold: ' num2str(nf)]); 

            load([outfolder,'accss',num2str(iii),'-',num2str(T),'-',num2str(nf),'.mat']);

            datafile = dataname;
            load(datafile)

            eW = reshape(param,[D,T,K]);
            Phi = reshape(exp(F*reshape(eW, [D, T*K])), [M, T, K]);
            Z = squeeze(sum(sum(Phi,3),2));
            PCO_F = bsxfun(@times, Phi, 1./Z);

            PCO_F_all = PCO_F_all + squeeze(sum(PCO_F,1));
        end
    end
end

save PCO_F_all.mat PCO_F_all

end
end
end


%PCO_F_all=(PCO_F_all-repmat(min(PCO_F_all,[],2),[1,size(PCO_F_all,2)]))./(repmat(max(PCO_F_all,[],2),[1,size(PCO_F_all,2)])-repmat(min(PCO_F_all,[],2),[1,size(PCO_F_all,2)]))
PCO_F_all = PCO_F_all./repmat(sum(PCO_F_all,2),[1,size(PCO_F_all,2)])

image(PCO_F_all*255)
colormap(jet(ceil(max(max(PCO_F_all*255)))))
colorbar('YTickLabel',[])
set(gca,'XTick',[1:size(PCO_F_all,2)])


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% get weights or probabilities on proteins from the best case
clear all
close all

load wrap_results2.mat  %% for the best case


load structFeat9-KN3-4HLR.mat antibodyids classlabels


j = 5;  %% for the best case
        [protlabels,protpredlabels,proteins,newallweights] = ...
            voteAcrossProtein( eP_all{j}, classlabels, antibodyids );

save wrap_results25.mat protlabels protpredlabels proteins newallweights

