function jl_PGM_fg(imagedir, maskdir, svmfile)


if ~exist('imagedir','var')
   imagedir = 'share/images/HPA/images/IFconfocal/';  %%
end

if ~exist('maskdir','var')
   maskdir = 'share/masks/';  %%
end


%% run to segment images.
% function segmentFields(readdir,writedir)
% readdir - the root directory contains all the images;
% writedir - the directory to write the segmentation masks.
if strcmp(maskdir(1),'/')~=1
   segmentFields(imagedir,maskdir);
end


%% calculate features for all the images
if ~exist('svmfile','var')
   svmfile = './HCRF/data/pc/HPAimage_info.mat';  %%
end

load(svmfile,'imagelist','antibodyids','classes','classlabels','protlabels','protpredlabels');

imagelist = regexprep(imagelist , '/share/images/HPA/images/IFconfocal/', imagedir);  %%

[imagelist,IX] = unique(imagelist);
antibodyids = antibodyids(IX);
classlabels = classlabels(IX);

   calcfeatures(imagedir,maskdir,imagelist,antibodyids); 

   fgfiles = dir('./HCRF/data/features/region/fg/*_fg.mat');
   tmpfiles = dir('./HCRF/tmp/*.txt');
   while length(fgfiles)<length(imagelist) || length(tmpfiles)>0
         pause(60);
         fgfiles = dir('./HCRF/data/features/region/fg/*_fg.mat');
         tmpfiles = dir('./HCRF/tmp/*.txt');
   end
   loadfeatures(imagedir,imagelist,antibodyids,classlabels,classes); %%





function calcfeatures(imagedir,maskdir,imagelist,antibodyids)

fsetnames = {...
    'fg'}; %%


datasettype = 'region';

if ~exist(['./HCRF/data/features/' lower(datasettype) '/fg/'],'dir')
   mkdir(['./HCRF/data/features/' lower(datasettype) '/fg/']);
end


rootdir1 = [imagedir];  %% root dir for raw images
filetype = 'tif';
greparg = ' | grep green';

ind1 = find(rootdir1=='/');
rootdir1_ = rootdir1;
rootdir1_(ind1) = '_';


if exist('imagelist','var')  %%
   readlist = imagelist;
   clear imagelist
   uout = listunixformat(readlist);

   [proteins,tmp,anti_IX] = unique(antibodyids);  %%
   prot_num = length(proteins);
end

uout_nuc = findreplacestring( uout, 'green','blue');
uout_tub = findreplacestring( uout, 'green','red');
uout_er = findreplacestring( uout, 'green','yellow');
readlist_nuc = listmatlabformat( uout_nuc);
readlist_tub = listmatlabformat( uout_tub);
readlist_er = listmatlabformat( uout_er);


mout = findreplacestring( uout, '/', '_');
mout = findreplacestring( mout, '.tif', '.png');
mout = findreplacestring( mout, rootdir1_, maskdir); %% segmentation masks


readlist_mask = listmatlabformat( mout);


cleanobject.channel_path = [];
cleanobject.channel = [];
cleanobject.channel_mcp = [];
cleanobject.channel_filtered = [];
cleanobject.channel_thr = [];
cleanobject.channel_mthr = [];
cleanobject.channel_fg = [];
cleanobject.channel_regions = [];
cleanobject.channel_objectsizes = [];
cleanobject.downsampled2x = [];
cleanobject.downsampled2x_filtered = [];
cleanobject.downsampled2x_thr = [];
cleanobject.downsampled2x_mthr = [];
cleanobject.downsampled2x_fg = [];
cleanobject.downsampled2x_objectsizes = [];
cleanobject.downsampled4x = [];
DSF = 2;

cellid = 0;  %%
length_readlist = length(readlist)
for i=1:length(readlist)
    anti = anti_IX(i);  %%
    i
    tmpfile = [readlist{i} '_' datasettype];
    tmpfile(find(tmpfile=='/')) = [];
    tmpfile(find(tmpfile=='.')) = [];
    tmpfile = ['./HCRF/tmp/' tmpfile '_REGION.txt'];

    if exist(tmpfile,'file')
        tmpfile
        continue;
    end
    fid = fopen(tmpfile,'w');

    protfieldstruct = cleanobject;
    nucfieldstruct = cleanobject;
    tubfieldstruct = cleanobject;
    erfieldstruct = cleanobject;
    maskfieldstruct = cleanobject;

    for zed = 1:length(fsetnames)
        mout = findreplacestring( readlist{i}, '/', '_');
        mout = findreplacestring( mout, '.tif', ['_' fsetnames{zed} '.mat']);
        if ~exist(['./HCRF/data/features/' lower(datasettype) '/fg/'],'dir')
           mkdir(['./HCRF/data/features/' lower(datasettype) '/fg/']);
        end
        writepath = findreplacestring( mout, rootdir1_, ['./HCRF/data/features/' lower(datasettype) '/fg/']); %%

        if exist(writepath,'file')
            i
            continue; %%
        end
        
        tmpfile2 = writepath;
        tmpfile2(find(tmpfile2=='/')) = [];
        tmpfile2(find(tmpfile2=='.')) = [];
        tmpfile2 = ['./HCRF/tmp/' tmpfile2 '_REGION.txt']; %%

        if exist(tmpfile2,'file')
            tmpfile2
            continue;
        end
        fid2 = fopen(tmpfile2,'w');

        protfieldstruct.channel_path = readlist{i};
        nucfieldstruct.channel_path = readlist_nuc{i};
        tubfieldstruct.channel_path = readlist_tub{i};
        erfieldstruct.channel_path = readlist_er{i};
        maskfieldstruct.channel_path = readlist_mask{i};

        maskAllChannels
        
        allfeats = [];
        for j=1:length(protfieldstruct.channel_regions)
            j
            protstruct = cleanobject;
            nucstruct = cleanobject;
            tubstruct = cleanobject;
            erstruct = cleanobject;
            maskstruct = cleanobject;

            protstruct.channel_path = readlist{i};
            nucstruct.channel_path = readlist_nuc{i};
            tubstruct.channel_path = readlist_tub{i};
            erstruct.channel_path = readlist_er{i};
            maskstruct.channel_path = readlist_mask{i};

            protstruct.channel = protfieldstruct.channel_regions{j};
            nucstruct.channel = nucfieldstruct.channel_regions{j};
            tubstruct.channel = tubfieldstruct.channel_regions{j};
            erstruct.channel = erfieldstruct.channel_regions{j};
            maskstruct.channel = maskfieldstruct.channel_regions{j};
 
            cellid = cellid+1; %%
            commonScriptCalculateSet

            feats = [feats,repmat(cellid,[size(feats,1),1])]; %%
            allfeats = [allfeats; feats];
        end

        feats = allfeats;
        impath = readlist{i};

        % saving results
        save( writepath,'feats','names','slfnames','impath');  %%

        fclose(fid2);
        delete(tmpfile2);
    end
    fclose(fid);
    delete(tmpfile);
end








function [names, feats, slfnames] = fg(prot, nuc, tub, er, mask, anti, prot_num)
disp('fg...');

prot = double(prot);
nuc = double(nuc);
tub = double(tub);
er = double(er);

if (sum(sum(prot))==0) || (sum(sum(nuc))==0)
   names = [];
   feats = [];
   slfnames = [];
   return;
end

Xn_prot = ml_imgmoments(prot,1,0)/ml_imgmoments(prot,0,0)
Yn_prot = ml_imgmoments(prot,0,1)/ml_imgmoments(prot,0,0)

Xn_nuc = ml_imgmoments(nuc,1,0)/ml_imgmoments(nuc,0,0)
Yn_nuc = ml_imgmoments(nuc,0,1)/ml_imgmoments(nuc,0,0)

if (Xn_prot<=0) || (Xn_prot>=size(prot,2)) || (Yn_prot<=0) || (Yn_prot>=size(prot,1)) || ...
   (Xn_nuc<=0) || (Xn_nuc>=size(nuc,2)) || (Yn_nuc<=0) || (Yn_nuc>=size(nuc,1))
   error('Check imgmoments!');
end


region_size = [min(size(prot,1),41),min(size(prot,2),41)];
region_num = 50;
thre = 0.8;

prot = prot.*double(mask);  %%consider only regions with protein intensity
[tmpr,tmpc] = find(prot);  %%
idx1 = find(tmpr>max(tmpr)-region_size(1)+1);  %% correction for previous versions
idx2 = find(tmpc>max(tmpc)-region_size(2)+1);  %% correction for previous versions
tmpr(unique([idx1(:);idx2(:)])) = [];  
tmpc(unique([idx1(:);idx2(:)])) = [];  
clear idx1 idx2

if (min(region_size)<=1)||(isempty(tmpr))||(isempty(tmpc))
   names = [];
   feats = [];
   slfnames = [];
   return;
end

idx = randperm(length(tmpr));
r = tmpr(idx);
c = tmpc(idx);
clear idx

i = region_num;

f = zeros(1,558+1980+region_size(1)*region_size(2)*4+4+4+2+2+4); %
feats = zeros(region_num,558+1980+region_size(1)*region_size(2)*4+4+4+2+2+4);
names = []; slfnames = [];
maxiter = max(length(r),length(c));
iter = 1;
allsize = size(prot);
allnuc = sum(sum(nuc)); alltub = sum(sum(tub)); aller = sum(sum(er)); allprot = sum(sum(prot));
while i && (iter<=maxiter) 
    leftup = [r(min(iter,length(r))),c(min(iter,length(c)))];
    im = double(mask(leftup(1):leftup(1)+region_size(1)-1,leftup(2):leftup(2)+region_size(2)-1));
    iter = iter+1;
    if sum(sum(im))/(size(im,1)*size(im,2))<thre
       continue;
    end
    i = i-1;
    im = zeros(size(prot));
    im(leftup(1):leftup(1)+region_size(1)-1,leftup(2):leftup(2)+region_size(2)-1) = 1;  %%

    tmpprot = prot.*im;
    tmpprot = reshape(tmpprot(im>0),[region_size(1),region_size(2)]);
    tmpnuc = nuc.*im;
    tmpnuc = reshape(tmpnuc(im>0),[region_size(1),region_size(2)]);
    tmptub = tub.*im;
    tmptub = reshape(tmptub(im>0),[region_size(1),region_size(2)]);
    tmper = er.*im;
    tmper = reshape(tmper(im>0),[region_size(1),region_size(2)]);

    center = [leftup(1)+floor(region_size(1)/2),leftup(2)+floor(region_size(2)/2)]; %
    if sum(sum(tmpprot))+sum(sum(tmpnuc))+sum(sum(tmptub))+sum(sum(tmper))==0
       f = [zeros(1,558+1980+region_size(1)*region_size(2)*4+4),[Yn_prot,Xn_prot],[Yn_nuc,Xn_nuc],center,allsize,allnuc,alltub,aller,allprot]; %%
    else
       [tmpf,names,slfnames] = SLFcalc(tmpprot, tmpnuc, tmptub, tmper);
       f = [tmpf,tmpprot(:)',tmpnuc(:)',tmptub(:)',tmper(:)',sum(sum(tmpprot)),sum(sum(tmpnuc)),sum(sum(tmptub)),sum(sum(tmper)),...
           [Yn_prot,Xn_prot],[Yn_nuc,Xn_nuc],center,allsize,allnuc,alltub,aller,allprot];
    end

    feats(region_num-i,:) = [f];
end
feats(region_num-i+1:end,:) = [];

feats = [feats,repmat(anti,[size(feats,1),1])];







function loadfeatures(imagedir,allimagelist,antis,labels,classes)

featsets = {...
        'fg'}; %%

region_size = [41,41]; %%

datasettype = 'region';

outfilename = ['./HCRF/data/pc/fg9_single_A431R2','.mat'];  %%

ulist = listunixformat( allimagelist);

tmplist = findreplacestring( ulist, '/','_');
tmplist = findreplacestring( tmplist,regexprep(imagedir,'/','_'),['./HCRF/data/features/region/fg/']);
flists = findreplacestring( tmplist, '.tif', ['_' featsets{1} '.mat']);
featlists = listmatlabformat( flists)';

allfeatures = [];
antibodyids = [];
classlabels = [];
imagelist = [];
cellids = [];
locations = [];
center_prot = [];
length(featlists)
for j=1:length(featlists)
    j
    if exist(featlists{j},'file')
       load(featlists{j})
    else
       error(['There is no file ',featlists{j}]);
    end
    feats=double(feats);

    allfeatures = [allfeatures;single(feats(:,1:558+1980))]; %%
    antibodyids = [antibodyids;repmat(antis(j),[size(feats,1),1])];
    classlabels = [classlabels;repmat(labels(j),[size(feats,1),1])];
    imagelist = [imagelist;repmat(allimagelist(j),[size(feats,1),1])];
    cellids = [cellids;feats(:,end)];  %%
    locations = [locations;feats(:,558+1980+region_size(1)*region_size(2)*4+4+4+1:558+1980+region_size(1)*region_size(2)*4+4+4+2)];
    center_prot = [center_prot;feats(:,558+1980+region_size(1)*region_size(2)*4+4+1:558+1980+region_size(1)*region_size(2)*4+4+2)];
    clear feats
end

specificity = int8(zeros(length(imagelist),1));
staining = int8(zeros(length(imagelist),1));
cellabels = int8(ones(length(imagelist),1));






function [allfeats,allnames,slfnames] = SLFcalc(theprot, thenuc, thetub, theer)

%calculate SLF features

fsetnames = {...
    'overlap', ...
    'overlapx2', ...
    'nonObjFluor', ...
    'nonObjFluorx2', ...
    'obj', ...
    'objx2', ...
    'mutualInfo', ...
    'mutualInfox2', ...
    'texture', ...
    'texturex2', ...
    'tas', ...
    'tasx2', ...
    'objRegion',...
    'objRegionx2',...
    'refColocal',...
    'refColocalx2',...
};


datasettype = 'region';


%Start to calculate SLF features
cleanobject.channel_path = [];
cleanobject.channel = [];
cleanobject.channel_mcp = [];
cleanobject.channel_filtered = [];
cleanobject.channel_thr = [];
cleanobject.channel_mthr = [];
cleanobject.channel_fg = [];
cleanobject.channel_regions = [];
cleanobject.channel_objectsizes = [];
cleanobject.downsampled2x = [];
cleanobject.downsampled2x_filtered = [];
cleanobject.downsampled2x_thr = [];
cleanobject.downsampled2x_mthr = [];
cleanobject.downsampled2x_fg = [];
cleanobject.downsampled2x_objectsizes = [];
cleanobject.downsampled4x = [];
DSF = 2;

allfeats = [];
allnames = [];
    for zed = 1:length(fsetnames)
                
            protstruct = cleanobject;
            nucstruct = cleanobject;
            tubstruct = cleanobject;
            erstruct = cleanobject;

            protstruct.channel = double(theprot);  %%
            nucstruct.channel = double(thenuc);  %%
            tubstruct.channel = double(thetub);  %%
            erstruct.channel = double(theer);  %%

            commonScriptCalculateSet

            allfeats = [allfeats, feats(:)'];
            allnames = [allnames, names(:)'];
            clear feats names
    end

clear protstruct nucstruct tubstruct erstruct 

slfnames = [];



