%% master script for running and generating results for the paper:
%% Protein Subcellular Location Pattern Classification in Cellular Images Using Latent Discriminative Models,
%% by Liang Xiong, Jieyue Li, Robert F. Murphy and Jeff Schneider.


addpath(genpath('./HCRF/lib'));

%% calculating features
%% please first download raw images in share directory.
jl_PGM_fg           % calculating features
%jl_PGM_fg('/share/images/HPA/images/IFconfocal/','/share/home/jieyuel/images/HPA/images/data/masks/')


%% running HCRF
cd ./HCRF
PGM_Project_Script  % feature reduction and preprocess
batch_cell_all      % running HCRF
wrap_results        % wrapping results
wrap_PCO_F          % wrapping probability map (PCO)
cd ..


%% running HLR
cd ./HLR
wrap4HLR            % wrapping data for HLR
batch_cell_all      % running HLR
wrap_trials         % wrapping results from different trials for HLR
wrap                % wrap the final accuracies for HLR
wrap_PCO_F          % wrapping probability map (PCO)
cd ..


%% generating results presented in the paper
cd ./HLR
demo_sim      % figure 6
cd ..
plot_curves         % figure 7, 8 and 9, and table 1

